"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var log4js = require("log4js");
var ab2str = require('arraybuffer-to-string');
var logger = log4js.getLogger('Cassandra');
var cassandraConn;
function IntegrationCassandraSql(app) {
    cassandraConn = app.get('cassandraConn');
}
exports.IntegrationCassandraSql = IntegrationCassandraSql;
function GetCassandraVCCs() {
    return new Promise(function (resolve, reject) {
        cassandraConn.execute('SELECT * FROM VCCs', [], function (err, rows) {
            if (err) {
                var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
                logger.error(errorMsg);
                reject(err);
            }
            else {
                var VCCs_1 = [];
                var vcc_1 = '';
                var description_1 = '';
                var nowUtc_1 = moment().utc().toDate();
                var allegroIntegration_1 = '';
                rows.map(function (row) {
                    description_1 = '';
                    allegroIntegration_1 = '';
                    row.cols.map(function (col) {
                        vcc_1 = '';
                        if (ab2str(col.name, 'utf8') === 'Id')
                            vcc_1 = ab2str(col.value, 'utf8');
                        if (ab2str(col.name, 'utf8') === 'Description')
                            description_1 = ab2str(col.value, 'utf8');
                        if (ab2str(col.name, 'utf8') === 'AllegroIntegration')
                            allegroIntegration_1 = ab2str(col.value, 'utf8');
                        if (vcc_1 !== '') {
                            var VCC_1 = {};
                            VCC_1.vcc = vcc_1;
                            VCC_1.id = vcc_1;
                            VCC_1.description = description_1;
                            VCC_1.allegroIntegration = allegroIntegration_1;
                            VCC_1.country = null;
                            VCC_1.language = null;
                            VCC_1.timeZone = null;
                            VCC_1.createdDate = nowUtc_1;
                            VCC_1.createdByUserId = 'admin';
                            VCC_1.lastModifiedDate = nowUtc_1;
                            VCC_1.lastModifiedByUserId = 'admin';
                            VCCs_1.push(VCC_1);
                        }
                    });
                });
                resolve(VCCs_1);
            }
        });
    });
}
exports.GetCassandraVCCs = GetCassandraVCCs;
function GetCassandraUsers() {
    return new Promise(function (resolve, reject) {
        cassandraConn.execute('SELECT * FROM Users', [], function (err, rows) {
            if (err) {
                var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
                logger.error(errorMsg);
                reject(err);
            }
            else {
                resolve(rows);
            }
        });
    });
}
exports.GetCassandraUsers = GetCassandraUsers;
