"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function ApiUserMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.ApiUserMSSql = ApiUserMSSql;
function GetApiUsers(vcc, search_criteria, search_expression) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetAPIUsers')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetApiUsers = GetApiUsers;
function SaveApiUser(apiUser) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), apiUser.vcc)
        .input('User', sql.VarChar(50), apiUser.user)
        .input('IsLocked', sql.Bit, apiUser.isLocked)
        .input('CreatedDate', sql.DateTime, apiUser.createdDate)
        .input('CreatedByUserId', sql.VarChar(50), apiUser.createdByUserId)
        .input('LastModifiedDate', sql.DateTime, apiUser.lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), apiUser.lastModifiedByUserId)
        .execute('SaveAPIUser')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveApiUser = SaveApiUser;
function GetApiUser(vcc, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('User', sql.VarChar(50), userId)
        .execute('GetAPIUser')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var user = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(user);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetApiUser = GetApiUser;
