"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function BatchMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.BatchMSSql = BatchMSSql;
function GetBatchDetail(vcc, batchTypeName, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .execute('GetBatchDetail')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var batchDetail = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(batchDetail);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing error ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetBatchDetail = GetBatchDetail;
function GetFinishedBatch() {
    return new sql.Request(sqlConn)
        .execute('GetFinishedBatch')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetFinishedBatch = GetFinishedBatch;
function SaveBatchStatus(vcc, batchTypeId, systemService, status) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .input('SystemService', sql.VarChar(50), systemService)
        .input('Status', sql.VarChar(50), status)
        .execute('SaveBatchStatus')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing error ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveBatchStatus = SaveBatchStatus;
function FinishedBatchClose(vcc, batchTypeName, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .execute('FinishedBatchClose')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.FinishedBatchClose = FinishedBatchClose;
