"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function HomeMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.HomeMSSql = HomeMSSql;
function GetHomeSummary(instance, startDate, endDate, clientOffset, userId) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('ClientOffset', sql.Int, clientOffset)
        .input('UserId', sql.VarChar(50), userId)
        .execute('GetHomeSummary')
        .then(function (recordsets) {
        return Promise.resolve(recordsets);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetHomeSummary = GetHomeSummary;
