"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function IdathaMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.IdathaMSSql = IdathaMSSql;
function GetIdathaAuthByRealm(vcc, realm) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Realm', sql.VarChar(50), realm)
        .execute('GetIdathaAuthByRealm')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var idathaAuth = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(idathaAuth);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetIdathaAuthByRealm = GetIdathaAuthByRealm;
function GetUserAccessTokenByRealm(vcc, realm) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Realm', sql.VarChar(50), realm)
        .execute('GetUserAccessTokenByRealm')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var userAccessToken = (recordset && recordset.length > 0 ? recordset[0] : null);
        if (userAccessToken) {
        }
        return Promise.resolve(userAccessToken);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetUserAccessTokenByRealm = GetUserAccessTokenByRealm;
function SaveIdathaAuth(vcc, userName, password, realm) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserName', sql.VarChar(50), userName)
        .input('Password', sql.VarChar(200), password)
        .input('Realm', sql.VarChar(100), realm)
        .execute('SaveIdathaAuth')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        console.log(err);
        return Promise.reject(err);
    });
}
exports.SaveIdathaAuth = SaveIdathaAuth;
function SaveUserAccessToken(vcc, userName, accessToken, realm, createdDate) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserName', sql.VarChar(50), userName)
        .input('AccessToken', sql.VarChar(2000), accessToken)
        .input('Realm', sql.VarChar(100), realm)
        .input('CreatedDate', sql.DateTime, createdDate)
        .execute('SaveUserAccessToken')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveUserAccessToken = SaveUserAccessToken;
