"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function InteractionTypeMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.InteractionTypeMSSql = InteractionTypeMSSql;
function GetInteractionTypes(instance, search_criteria, search_expression) {
    logger.info('[InteractionTypeMSSql::GetInteractionTypes] Received search_criteria: ' + search_criteria);
    logger.info('[InteractionTypeMSSql::GetInteractionTypes] Received search_expression: ' + search_expression);
    logger.info('[InteractionTypeMSSql::GetInteractionTypes] Calling SP GetInteractionTypes');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetInteractionTypes')
        .then(function (recordsets) {
        logger.info('[InteractionTypeMSSql::GetInteractionTypes] Received result from SP GetInteractionTypes: ' + recordsets.length);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionTypeMSSql::GetInteractionTypes] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractionTypes = GetInteractionTypes;
function SaveInteractionType(instance, id, description) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), id)
        .input('Description', sql.VarChar(100), description)
        .execute('SaveInteractionType')
        .then(function (recordsets) {
        logger.info('[InteractionTypeMSSql::SaveInteractionType] Received result from SP SaveInteractionType: ' + recordsets.length);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionTypeMSSql::SaveInteractionType] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveInteractionType = SaveInteractionType;
