"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function ProfileImageMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.ProfileImageMSSql = ProfileImageMSSql;
function GetProfileImage(instance, type, id) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('Type', sql.VarChar(50), type)
        .input('ID', sql.VarChar(50), id)
        .execute('GetProfileImage')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var profileImage = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(profileImage);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetProfileImage = GetProfileImage;
