"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var redis_config_1 = require("../../config/redis.config");
var logger = log4js.getLogger('Redis');
var redisClient;
function EvaluationPlanAbilityRedis(app) {
    redisClient = app.get('redisClient');
}
exports.EvaluationPlanAbilityRedis = EvaluationPlanAbilityRedis;
function SaveEvaluationPlanAbilities(vcc, evaluationPlanId, abilities) {
    var storage = 'EvaluationPlanAbility';
    var key = '';
    key += vcc;
    key += ':';
    key += evaluationPlanId;
    if (!key)
        return Promise.resolve(false);
    return redisClient.hsetAsync(storage, key, JSON.stringify(abilities))
        .then(function (result) {
        return redisClient.expireAsync(storage, redis_config_1.REDIS_DATA_PERSISTENCE);
    })
        .then(function (result) {
        return Promise.resolve(true);
    })
        .catch(function (err) {
        logger.error('[EvaluationPlanAbilityRedis::SaveEvaluationPlanAbility] getting error:', err, 'key:', key);
        return Promise.resolve(err);
    });
}
exports.SaveEvaluationPlanAbilities = SaveEvaluationPlanAbilities;
function GetEvaluationPlanAbilities(vcc, evaluationPlanId) {
    var key = '';
    key += vcc;
    key += ':';
    key += evaluationPlanId;
    return redisClient.hgetAsync('EvaluationPlanAbility', key)
        .then(function (result) {
        var interaction = [];
        try {
            interaction = (typeof result === 'string') ? JSON.parse(result) : result;
        }
        catch (err) {
            return Promise.resolve(null);
        }
        return interaction;
    })
        .catch(function (err) {
        logger.error('[EvaluationPlanAbilityRedis::GetEvaluationPlanAbilities] getting error:', err, 'key:', key);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilities = GetEvaluationPlanAbilities;
function RemoveEvaluationPlanAbilities(vcc, evaluationPlanId) {
    var storage = 'EvaluationPlanAbility';
    var key = '';
    key += vcc;
    key += ':';
    key += evaluationPlanId;
    return redisClient.hdelAsync(storage, key)
        .then(function (result) {
        return Promise.resolve(result);
    })
        .catch(function (err) {
        logger.error('[EvaluationPlanAbilityRedis::RemoveEvaluationPlanAbilities] getting error:', err, 'key:', key);
        return Promise.resolve(err);
    });
}
exports.RemoveEvaluationPlanAbilities = RemoveEvaluationPlanAbilities;
