"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var redis_config_1 = require("../../config/redis.config");
var logger = log4js.getLogger('Redis');
var redisClient;
function StudyTemplateThemeRedis(app) {
    redisClient = app.get('redisClient');
}
exports.StudyTemplateThemeRedis = StudyTemplateThemeRedis;
function SaveStudyTemplateThemes(vcc, studyId, themes) {
    var storage = 'StudyTemplateTheme';
    var key = '';
    key += vcc;
    key += ':';
    key += studyId;
    if (!key)
        return Promise.resolve(false);
    return redisClient.hsetAsync(storage, key, JSON.stringify(themes))
        .then(function (result) {
        return redisClient.expireAsync(storage, redis_config_1.REDIS_DATA_PERSISTENCE);
    })
        .then(function (result) {
        return Promise.resolve(true);
    })
        .catch(function (err) {
        logger.error('[StudyThemeRedis::SaveStudyTemplateThemes] getting error:', err, 'key:', key);
        return Promise.resolve(err);
    });
}
exports.SaveStudyTemplateThemes = SaveStudyTemplateThemes;
function GetStudyTemplateThemes(vcc, studyId) {
    var key = '';
    key += vcc;
    key += ':';
    key += studyId;
    return redisClient.hgetAsync('StudyTemplateTheme', key)
        .then(function (result) {
        var themes = [];
        try {
            themes = (typeof result === 'string') ? JSON.parse(result) : result;
        }
        catch (err) {
            return Promise.resolve(null);
        }
        return themes;
    })
        .catch(function (err) {
        logger.error('[StudyThemeRedis::GetStudyTemplateThemes] getting error:', err, 'key:', key);
        return Promise.reject(err);
    });
}
exports.GetStudyTemplateThemes = GetStudyTemplateThemes;
function RemoveStudyTemplateThemes(vcc, studyId) {
    var storage = 'StudyTemplateTheme';
    var key = '';
    key += vcc;
    key += ':';
    key += studyId;
    return redisClient.hdelAsync(storage, key)
        .then(function (result) {
        return Promise.resolve(result);
    })
        .catch(function (err) {
        logger.error('[StudyTemplateThemeRedis::RemoveStudyTemplateThemes] getting error:', err, 'key:', key);
        return Promise.resolve(err);
    });
}
exports.RemoveStudyTemplateThemes = RemoveStudyTemplateThemes;
