"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var BillingVCCRates = (function () {
    function BillingVCCRates() {
        this.cognitiveAnalysisAverageRequestPerMinute = 0;
        this.cognitiveAnalysisAverageSecondsPerRequest = 0;
        this.cognitiveAnalysisCallBillingSecureRate = 0;
        this.semanticAnalysisRatePerTransaction = 0;
        this.cognitiveAnalysisTextBillingSecureRate = 0;
        this.isProcessPostChannel = false;
        this.processCallPhrases = 0;
        this.processRoundedValidDurationTime = 0;
        this.processTextPhrases = 0;
        this.processTotalValidDurationTime = 0;
        this.cognitiveAnalysisRatePerTransaction = 0;
        this.transcriptionRatePerHour = 0;
        this.transcriptionRatePerSecond = 0;
        this.totalCost = 0.00001;
    }
    BillingVCCRates.prototype.SetBillingVCCRates = function (object) {
        this.cognitiveAnalysisAverageRequestPerMinute = object.cognitiveAnalysisAverageRequestPerMinute;
        this.cognitiveAnalysisAverageSecondsPerRequest = object.cognitiveAnalysisAverageSecondsPerRequest;
        this.cognitiveAnalysisCallBillingSecureRate = object.cognitiveAnalysisBillingSecureRate;
        this.semanticAnalysisRatePerTransaction = object.semanticAnalysisRatePerTransaction;
        this.cognitiveAnalysisTextBillingSecureRate = object.cognitiveAnalysisTextBillingSecureRate;
        this.isProcessPostChannel = object.isProcessPostChannel;
        this.processCallPhrases = object.processCallPhrases;
        this.processRoundedValidDurationTime = object.processRoundedValidDurationTime;
        this.processTextPhrases = object.processTextPhrases;
        this.processTotalValidDurationTime = object.processTotalValidDurationTime;
        this.cognitiveAnalysisRatePerTransaction = object.cognitiveAnalysisRatePerTransaction;
        this.transcriptionRatePerHour = object.transcriptionRatePerHour;
        this.transcriptionRatePerSecond = object.transcriptionRatePerSecond;
    };
    BillingVCCRates.prototype.GetCognitiveAnalysisTotalAveragePhrasesFromProcess = function () {
        var cognitiveAnalysisTotalAveragePhrases = 0;
        if (this.isProcessPostChannel) {
            cognitiveAnalysisTotalAveragePhrases = (this.processCallPhrases * (1 + this.cognitiveAnalysisCallBillingSecureRate))
                + (this.processTextPhrases * (1 + this.cognitiveAnalysisTextBillingSecureRate));
        }
        return cognitiveAnalysisTotalAveragePhrases;
    };
    BillingVCCRates.prototype.GetCognitiveAnalysisTotalCostFromProcess = function (totalModels) {
        var cognitiveTotalCost = 0;
        if (this.isProcessPostChannel) {
            cognitiveTotalCost = totalModels
                * Math.ceil(this.cognitiveAnalysisRatePerTransaction
                    * this.GetCognitiveAnalysisTotalAveragePhrasesFromProcess());
        }
        return cognitiveTotalCost;
    };
    BillingVCCRates.prototype.GetCognitiveAnalysisTotalAveragePhrasesFromNone = function (estimatedRequests) {
        var cognitiveAnalysisTotalAveragePhrases = 0;
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromCallTime || 0) * (1 + this.cognitiveAnalysisCallBillingSecureRate);
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestFromCallAlreadyPhrases || 0) * (1 + this.cognitiveAnalysisCallBillingSecureRate);
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromTextRawChar || 0) * (1 + this.cognitiveAnalysisTextBillingSecureRate);
        cognitiveAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromTextAlreadyPhrases || 0) * (1 + this.cognitiveAnalysisTextBillingSecureRate);
        return cognitiveAnalysisTotalAveragePhrases;
    };
    return BillingVCCRates;
}());
exports.BillingVCCRates = BillingVCCRates;
var BillingMovement = (function () {
    function BillingMovement(startDate, endDate, accountId, subAccountId, vcc, type) {
        if (accountId === void 0) { accountId = null; }
        if (subAccountId === void 0) { subAccountId = null; }
        if (vcc === void 0) { vcc = null; }
        if (type === void 0) { type = null; }
        this.startDate = startDate;
        this.endDate = endDate;
        this.accountId = accountId;
        this.subAccountId = subAccountId;
        this.vcc = vcc;
        this.type = type;
    }
    return BillingMovement;
}());
exports.BillingMovement = BillingMovement;
