"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var log4js = require("log4js");
var mssql_service_1 = require("../db/mssql.service");
var promises_shared_1 = require("../shared/promises.shared");
var logger = log4js.getLogger('ServerScripts');
function CampaignFulfillmentService(app) {
    app.post('/api/campaign_fulfillment/get_campaign_fulfillment/', function (req, res, next) {
        logger.info('[CampaignFulfillmentService::get_campaign_fulfillment] Received ' + req.method + ' method on \'' + req.path + '\'');
        var instance = res.locals.instance;
        logger.info('[CampaignFulfillmentService::get_campaign_fulfillment] Instance: ' + instance);
        var initialDate = req.body.initialDate ? moment(req.body.initialDate).toDate() : null;
        var endDate = req.body.endDate ? moment(req.body.endDate).toDate() : null;
        var campaigns = (req.body.campaigns && req.body.campaigns !== undefined) ? req.body.campaigns : null;
        var evaluationFormats = (req.body.evaluationFormats && req.body.evaluationFormats !== undefined) ? req.body.evaluationFormats : null;
        var evaluationPlans = (req.body.evaluationPlans && req.body.evaluationPlans !== undefined) ? req.body.evaluationPlans : null;
        var agents = (req.body.agents && req.body.agents !== undefined) ? req.body.agents : null;
        var idGroup = (req.body.idGroup && req.body.idGroup !== 0) ? req.body.idGroup : null;
        var idSubGroup = (req.body.idSubGroup && req.body.idSubGroup !== 0) ? req.body.idSubGroup : null;
        var idAbility = (req.body.idAbility && req.body.idAbility !== 0) ? req.body.idAbility : null;
        var auditors = (req.body.auditors && req.body.auditors !== undefined) ? req.body.auditors : null;
        promises_shared_1.DummyPromise()
            .then(function (result) {
            if (initialDate && endDate) {
                return mssql_service_1.MSSql.GetCampaignFulfillment(instance, initialDate, endDate, campaigns, evaluationFormats, evaluationPlans, agents, idGroup, idSubGroup, idAbility, auditors);
            }
            else {
                return [];
            }
        }).then(function (resultCumplimientoCampana) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'OK', data: (resultCumplimientoCampana ? resultCumplimientoCampana : []) });
        }).catch(function (err) {
            var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('[CampaignFulfillmentService::get_campaign_fulfillment]  Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: clientMsg, error: errorMsg });
        });
    });
}
exports.CampaignFulfillmentService = CampaignFulfillmentService;
