"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rp = require("request-promise-native");
var moment = require("moment");
var log4js = require("log4js");
var mssql_service_1 = require("../db/mssql.service");
var promises_shared_1 = require("../shared/promises.shared");
var SSH2Promise = require("ssh2-promise");
var Client = require('ftp');
var config_1 = require("../config/config");
var logger = log4js.getLogger('ServerScripts');
function EnvironmentService(app) {
    app.post('/api/environment/get_environments/:search_criteria/:search_expression?', function (req, res, next) {
        logger.info('[EnvironmentService::get_environments] Received ' + req.method + ' method on \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var search_criteria = req.params.search_criteria || '';
        var search_expression = req.params.search_expression || '';
        var search_allegro = req.body.includeAllegro !== undefined ? req.body.includeAllegro : true;
        promises_shared_1.DummyPromise()
            .then(function (result) {
            return mssql_service_1.MSSql.GetEnvironments(vcc, search_criteria, search_expression, search_allegro);
        }).then(function (resultEnvironments) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'OK', data: resultEnvironments });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.get('/api/environment/get_environment/:environment_id', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var environmentId = req.params.environment_id;
        var environment = null;
        promises_shared_1.DummyPromise()
            .then(function (result) {
            if (!environmentId)
                throw 'Missing environmentId input parameter';
            return mssql_service_1.MSSql.GetEnvironment(vcc, environmentId);
        }).
            then(function (env) {
            environment = env;
            return mssql_service_1.MSSql.GetEnvironmentsUsage(vcc, environmentId);
        }).then(function (usages) {
            if (!environment)
                throw 'Not found environment';
            if (res.headersSent)
                return;
            environment.dbPassword = '******';
            environment.pbxPassword = '******';
            environment.inUse = (usages.plans.length > 0 || usages.process.length > 0);
            res.json({ status: true, description: 'OK', data: environment, usages: usages });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.get('/api/environment/get_environment_type_by_name/:environment_id', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var environmentId = req.params.environment_id;
        promises_shared_1.DummyPromise()
            .then(function (result) {
            if (!environmentId)
                throw 'Missing environmentId input parameter';
            return mssql_service_1.MSSql.GetEnvironmentTypeByName(vcc, environmentId);
        }).then(function (resultEnvironmentType) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'OK', data: resultEnvironmentType });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.get('/api/environment/get_environment_vcc_list/:search_criteria/:search_expression?', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var search_criteria = req.params.search_criteria || '';
        var search_expression = req.params.search_expression || '';
        promises_shared_1.DummyPromise()
            .then(function (result) {
            return mssql_service_1.MSSql.GetEnvironmentVccs(vcc, search_criteria, search_expression);
        }).then(function (resultEnvironmentVccs) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'OK', data: resultEnvironmentVccs });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.post('/api/environment/create_environment', function (req, res, next) {
        logger.info('[EnvironmentService::create_environment] Received ' + req.method + ' method on \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var userId = res.locals.userId;
        var nowUtc = moment().utc().toDate();
        var newEnvironment = (req.body || {});
        newEnvironment.apiUser = newEnvironment.apiUser.trim();
        newEnvironment.apiPassword = newEnvironment.apiPassword.trim();
        newEnvironment.apiHost = newEnvironment.apiHost.trim();
        newEnvironment.apiPort = newEnvironment.apiPort;
        newEnvironment.createdDate = nowUtc;
        newEnvironment.createdByUserId = userId;
        newEnvironment.lastModifiedDate = nowUtc;
        newEnvironment.lastModifiedByUserId = userId;
        newEnvironment.dbDisabled = (newEnvironment.dbDisabled ? newEnvironment.dbDisabled : false);
        logger.info('[EnvironmentService::create_environment] Params: ', newEnvironment);
        promises_shared_1.DummyPromise()
            .then(function (result) {
            return mssql_service_1.MSSql.GetEnvironmentByName(vcc, newEnvironment.name);
        }).then(function (resultEnvironment) {
            if (resultEnvironment)
                throw 'Ya existe un ambiente con el nombre \'' + newEnvironment.name + '\'';
            return SaveEnvironment(vcc, newEnvironment);
        }).then(function (resultSaveEnvironment) {
            return Promise.resolve(resultSaveEnvironment);
        }).then(function (resultSaveEnvironment) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: (resultSaveEnvironment ? 'OK' : 'Environment save failed'), data: resultSaveEnvironment });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('[EnvironmentService::create_environment] Error on \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg, detail: { type: 'ERROR', datetime: moment().utc().toDate(), pid: process.pid, source: __filename, stack: err.stack } });
        });
    });
    app.post('/api/environment/save_environment', function (req, res, next) {
        logger.info('[EnvironmentService::save_environment] Received ' + req.method + ' method on \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var userId = res.locals.userId;
        var nowUtc = moment().utc().toDate();
        var environment = (req.body || {});
        environment.apiUser = environment.apiUser.trim();
        environment.apiPassword = environment.apiPassword.trim();
        environment.apiHost = environment.apiHost.trim();
        environment.apiPort = environment.apiPort;
        environment.createdDate = null;
        environment.createdByUserId = null;
        environment.lastModifiedDate = nowUtc;
        environment.lastModifiedByUserId = userId;
        promises_shared_1.DummyPromise()
            .then(function (resultDeleteEnvironment) {
            if (!resultDeleteEnvironment)
                throw 'Error al ejecutar solicitud';
            return SaveEnvironment(vcc, environment);
        }).then(function (resultSaveEnvironment) {
            if (!resultSaveEnvironment)
                return false;
            return Promise.resolve(true);
        }).then(function (resultSaveEnvironment) {
            if (res.headersSent)
                return;
            res.json({ status: resultSaveEnvironment, description: (resultSaveEnvironment ? 'OK' : 'Environment save failed'), data: resultSaveEnvironment });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('[EnvironmentService::save_environment] Error on \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.post('/api/environment/delete_environment', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var environment = req.body.environment;
        var environmentId = environment.name;
        promises_shared_1.DummyPromise()
            .then(function (_) {
            if (!environment)
                throw 'Missing environment input parameter';
            return mssql_service_1.MSSql.GetEnvironmentsUsage(vcc, environmentId);
        })
            .then(function (usages) {
            if (usages.plans.length > 0 || usages.process.length > 0) {
                throw 'ENVIRONMENT_IS_USED';
            }
            return mssql_service_1.MSSql.DeleteEnvironment(vcc, environmentId);
        }).then(function (resultDeleteEnvironment) {
            if (!resultDeleteEnvironment)
                throw 'Se produjo un error al eliminar el ambiente';
            return Promise.resolve(true);
        }).then(function (resultDeleteEnvironment) {
            if (res.headersSent)
                return;
            if (resultDeleteEnvironment)
                logger.info('Ambiente \'' + environmentId + '\' eliminado correctamente');
            res.json({ status: resultDeleteEnvironment, description: (resultDeleteEnvironment ? 'OK' : 'Environment delete failed'), data: resultDeleteEnvironment });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.post('/api/environment/delete_environments', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var environments = req.body.environments || [];
        var environmentIds = environments.map(function (e) { return e.name; });
        promises_shared_1.DummyPromise()
            .then(function (_) {
            if (!environments)
                throw 'Missing environments input parameter';
            return mssql_service_1.MSSql.GetEnvironmentsUsage(vcc, environmentIds.toString());
        })
            .then(function (usages) {
            if (usages.plans.length > 0 || usages.process.length > 0) {
                throw 'ENVIRONMENTS_IN_USE';
            }
            var promiseArray = [];
            environmentIds.forEach(function (environment) {
                promiseArray.push(mssql_service_1.MSSql.DeleteEnvironment(vcc, environment));
            });
            return Promise.all(promiseArray);
        }).then(function (resultDeleteEnvironments) {
            var result;
            if (resultDeleteEnvironments.filter(function (result) { return (result !== true); }).length > 0) {
                result = false;
                logger.error('No se pudo eliminar todos los elementos solicitados.');
            }
            else {
                result = true;
                logger.info('Ambientes eliminados correctamente');
            }
            return result;
        }).then(function (resultDeleteEnvironments) {
            if (res.headersSent)
                return;
            var description = (resultDeleteEnvironments ? 'OK' : 'Environments delete failed');
            res.json({
                status: resultDeleteEnvironments,
                description: description,
                data: resultDeleteEnvironments
            });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.post('/api/environment/test_environment', function (req, res) {
        var params = {
            host: req.body.apiHost,
            port: req.body.apiPort,
            password: req.body.apiPassword,
        };
        if (req.body.type == "sftp") {
            TestSFTP(Object.assign(params, {
                username: req.body.apiUser,
                readyTimeout: config_1.FTP_CONNECTION_TIMEOUT
            }), req.body.ftpDirectory).then(function (result) {
                res.json(result);
            });
        }
        else {
            TestFTP(Object.assign(params, {
                user: req.body.apiUser,
                connTimeout: config_1.FTP_CONNECTION_TIMEOUT,
                pasvTimeout: config_1.FTP_CONNECTION_TIMEOUT,
            }), req.body.ftpDirectory).then(function (result) {
                res.json(result);
            }).catch(function (err) {
                logger.error('[EnvironmentService::test_environment] Error on \'' + req.path + '\': ' + err);
                res.json({ status: false, code: err });
            });
        }
    });
    function TestSFTP(config, dir) {
        var ssh2 = new SSH2Promise(config);
        var response = { status: false };
        return new Promise(function (resolve, reject) {
            ssh2.connect().then(function () {
                var sftp = ssh2.sftp();
                sftp.readdir(dir).then(function (result) {
                    response.status = result ? true : false;
                    response.code = 'SERVER_SUCCESS_SFTP_CONNECTION';
                    response.result = result;
                    sftp.close();
                    resolve(response);
                }).catch(function (err) {
                    logger.error('[EnvironmentService::test_environment] Error on TestSFTP ', err.toString());
                    response.code = 'SERVER_ERROR_SFTP_PATH_NOT_FOUND';
                    resolve(response);
                });
            }).catch(function (err) {
                logger.error('[EnvironmentService::test_environment] Error on TestSFTP ', err.toString());
                if (err.level == "client-authentication") {
                    response.code = 'SERVER_ERROR_BAD_USER_OR_PASSWORD';
                }
                else if (err.level == "client-socket") {
                    response.code = 'SERVER_ERROR_BAD_IP';
                }
                else {
                    response.code = 'SERVER_ERROR_NOT_SFTP_CLIENT';
                }
                resolve(response);
            });
        });
    }
    function TestFTPDir(client, dir) {
        return new Promise(function (resolve, reject) {
            client.list(dir, function (err, list) {
                if (err) {
                    logger.error('[EnvironmentService::test_environment] Error on TestFTPDir ', err.toString());
                    reject("SERVER_ERROR_FTP_PATH_NOT_FOUND");
                }
                else {
                    resolve({ status: true, list: list, code: 'SERVER_SUCCESS_FTP_CONNECTION' });
                }
            });
        });
    }
    function TestFTP(config, dir) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var clientFtp, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        clientFtp = new Client();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, clientFtp.connect(config)];
                    case 2:
                        _a.sent();
                        if (clientFtp) {
                            clientFtp.on('ready', function () { return __awaiter(_this, void 0, void 0, function () {
                                var _a, error_1;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            _b.trys.push([0, 2, , 3]);
                                            _a = resolve;
                                            return [4, TestFTPDir(clientFtp, dir)];
                                        case 1:
                                            _a.apply(void 0, [_b.sent()]);
                                            return [3, 3];
                                        case 2:
                                            error_1 = _b.sent();
                                            reject(error_1);
                                            return [3, 3];
                                        case 3: return [2];
                                    }
                                });
                            }); });
                            clientFtp.on('end', function () {
                                reject('SERVER_ERROR_FTP_CONNECTION_ENDED');
                            });
                            clientFtp.on('close', function (hadError) {
                                reject('SERVER_ERROR_FTP_CONNECTION_REFUSED');
                            });
                            clientFtp.on('error', function (err) {
                                logger.error('[EnvironmentService::test_environment] Error on TestFTP ' + err.toString());
                                reject('SERVER_ERROR_NOT_FTP_CLIENT');
                            });
                        }
                        else {
                            reject('SERVER_ERROR_NOT_FTP_CLIENT');
                        }
                        return [3, 4];
                    case 3:
                        err_1 = _a.sent();
                        reject(err_1);
                        return [3, 4];
                    case 4: return [2];
                }
            });
        }); });
    }
    app.get('/api/environment/allegro/ping_environment/:environment_id', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var environmentId = req.params.environment_id;
        promises_shared_1.DummyPromise()
            .then(function (result) {
            if (!environmentId)
                throw 'Missing environment input parameter';
            return GetEnvironment(vcc, environmentId);
        }).then(function (resultEnvironment) {
            return PingAllegroEnvironment(resultEnvironment.apiHost, resultEnvironment.apiPort);
        }).then(function (response) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'OK', data: response });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.get('/api/environment/allegro/get_vcc_list/:search_criteria/:search_expression?', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var search_criteria = req.params.search_criteria || '';
        var search_expression = req.params.search_expression || '';
        promises_shared_1.DummyPromise()
            .then(function (resultEnvironment) {
            return mssql_service_1.MSSql.GetAllegroVccs(vcc, search_criteria, search_expression);
        }).then(function (vccList) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'OK', data: vccList });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
    app.post('/api/environment/allegro/get_bulk_vcc/:environment_id', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var userId = res.locals.userId;
        var nowUtc = moment().utc().toDate();
        var environmentId = req.params.environment_id;
        promises_shared_1.DummyPromise()
            .then(function (result) {
            return GetEnvironment(vcc, environmentId);
        }).then(function (resultEnvironment) {
            return GetBulkVcc(vcc, resultEnvironment, userId);
        }).then(function (resultSaveBulkVcc) {
            if (!resultSaveBulkVcc)
                return false;
            return Promise.resolve(true);
        }).then(function (resultSaveBulkVcc) {
            if (res.headersSent)
                return;
            res.json({ status: resultSaveBulkVcc, description: (resultSaveBulkVcc ? 'OK' : 'BulkVcc save failed'), data: resultSaveBulkVcc });
        }).catch(function (err) {
            var environmentMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: environmentMsg, error: errorMsg });
        });
    });
}
exports.EnvironmentService = EnvironmentService;
function GetEnvironment(vcc, id) {
    var cacheUpdateNeeded = false;
    return Promise.resolve()
        .then(function () {
        return mssql_service_1.MSSql.GetEnvironment(vcc, id);
    }).catch(function (err) {
        var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error al ejecutar GetEnvironment: ' + errMsg);
    });
}
function GetEnvironmentTypeByName(vcc, id) {
    var cacheUpdateNeeded = false;
    return Promise.resolve()
        .then(function () {
        return mssql_service_1.MSSql.GetEnvironmentTypeByName(vcc, id);
    }).catch(function (err) {
        var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error al ejecutar GetEnvironment: ' + errMsg);
    });
}
function PingAllegroEnvironment(ip, port) {
    var options = {
        url: 'http://' + ip + (port === '80' ? '' : ':' + port) + '/inconcert/apps/login/form?app=dashboard',
        method: 'GET',
        json: true,
        strictSSL: false,
        timeout: 5000,
    };
    return rp(options).catch(function (err) {
        if (err && err.message && err.message.includes('ECONNREFUSED')) {
            logger.warn('Se produjo un error de conexión al enviar request hacia \'' + options.url + '\'. Se hará un reintento.');
            return rp(options);
        }
        throw err;
    }).then(function (response) {
        if (response.statusCode === 200) {
            return JSON.parse(response.complete);
        }
        else {
            throw response.message || response.internalCode || '';
        }
    });
}
exports.PingAllegroEnvironment = PingAllegroEnvironment;
function SaveEnvironment(vcc, environment) {
    var promiseArray = [];
    promiseArray.push(mssql_service_1.MSSql.SaveEnvironment(vcc, environment.name, environment.type, environment.description, environment.ftpDirectory, environment.apiHost, environment.apiPort, environment.apiUser, (environment.apiPassword === '******' ? null : environment.apiPassword), environment.dbDisabled, environment.dbServer, environment.dbPort, environment.dbUser, (environment.dbPassword === '******' ? null : environment.dbPassword), environment.pbxDisabled, environment.pbxServer, environment.pbxPort, environment.pbxUser, (environment.pbxPassword === '******' ? null : environment.pbxPassword), environment.createdDate, environment.createdByUserId, environment.lastModifiedDate, environment.lastModifiedByUserId));
    return Promise.all(promiseArray).then(function (results) {
        if (results.filter(function (result) { return (result !== true); }).length > 0) {
            return false;
        }
        else {
            return true;
        }
    });
}
function SaveEnvironments(vcc, environments) {
    var promiseArray = [];
    if (environments) {
        environments.forEach(function (environment) {
            promiseArray.push(mssql_service_1.MSSql.SaveEnvironment(vcc, environment.name, environment.type, environment.description, environment.ftpDirectory, environment.apiHost, environment.apiPort, environment.apiUser, (environment.apiPassword === '******' ? null : environment.apiPassword), environment.dbDisabled, environment.dbServer, environment.dbPort, environment.dbUser, (environment.dbPassword === '******' ? null : environment.dbPassword), environment.pbxDisabled, environment.pbxServer, environment.pbxPort, environment.pbxUser, (environment.pbxPassword === '******' ? null : environment.pbxPassword), environment.createdDate, environment.createdByUserId, environment.lastModifiedDate, environment.lastModifiedByUserId));
        });
    }
    return Promise.all(promiseArray).then(function (results) {
        if (results.filter(function (result) { return (result !== true); }).length > 0) {
            return false;
        }
        else {
            return true;
        }
    });
}
exports.SaveEnvironments = SaveEnvironments;
function GetBulkVcc(vcc, environment, userId) {
    return promises_shared_1.DummyPromise()
        .then(function (result) {
        return mssql_service_1.MSSql.GetAllegroIntegrationVccs(environment);
    }).then(function (resultVccs) {
        return mssql_service_1.MSSql.BulkAllegroVccTemp(vcc, environment, resultVccs, userId);
    }).catch(function (err) {
        var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error al ejecutar BulkVcc: ' + errMsg);
    });
}
