"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var request = require("request-promise-native");
var NodeSSH = require('node-ssh').NodeSSH;
var log4js = require("log4js");
var scp2 = require('scp2');
var idatha_model_1 = require("../models/idatha.model");
var mssql_service_1 = require("../db/mssql.service");
var file_manager_1 = require("../shared/file-manager");
var promises_shared_1 = require("../shared/promises.shared");
var config_1 = require("../config/config");
var redis_service_1 = require("../db/redis.service");
var cognitive_analysis_implementation_1 = require("../implementation/cognitive-analysis.implementation");
var semantic_query_implementation_1 = require("../implementation/semantic-query.implementation");
var logger = log4js.getLogger('ServerScripts');
function IdathaService(app) {
    var cognitiveService;
    app.post('/api/idatha_auth/get_idatha_auth_by_realm', function (req, res, next) {
        req.setTimeout(7.2e+6, function () { });
        logger.info('[IdathaService::get_idatha_auth_by_realm] Received ' + req.method + ' method on \'' + req.path + '\'');
        var vcc = res.locals.vcc;
        var azure = res.locals.azure;
        var userId = res.locals.userId;
        var objData = (req.body || {});
        var userName = '';
        var password = '';
        var accessToken = '';
        var visual = [];
        var auditive = [];
        var kinestesic = [];
        var words = objData.words;
        var wordsDeleted = objData.wordsDeleted;
        var processId = objData.id;
        promises_shared_1.DummyPromise()
            .then(function (result) {
            return cognitive_analysis_implementation_1.GetCognitiveService(vcc, null);
        }).then(function (result) {
            cognitiveService = result;
            if (!objData.name)
                throw 'Missing realm input parameter';
            if (objData.name === 'init')
                return Promise.resolve({ name: objData.name, isSystem: true });
            return mssql_service_1.MSSql.GetIdathaAuthByRealm(vcc, vcc);
        }).then(function (resultIdathaAuthByRealm) {
            if (resultIdathaAuthByRealm && resultIdathaAuthByRealm.isSystem) {
                return Promise.resolve({ name: objData.name, isSystem: true });
            }
            else if (resultIdathaAuthByRealm && resultIdathaAuthByRealm.userName) {
                userName = resultIdathaAuthByRealm.userName;
                password = resultIdathaAuthByRealm.password;
                return mssql_service_1.MSSql.GetUserAccessTokenByRealm(vcc, vcc);
            }
            else {
                userName = 'user_speech';
                password = 'inc0nc3rt2019';
                var idathaAuth = { vcc: vcc, userName: userName, password: password, realm: vcc };
                return IdathaRegister(res.locals.api.idatha, idathaAuth);
            }
        })
            .then(function (resultUserAccessTokenByRealm) {
            if (resultUserAccessTokenByRealm.accessToken) {
                accessToken = resultUserAccessTokenByRealm.accessToken;
                var currentDate = new Date(), createdDate = new Date(resultUserAccessTokenByRealm.createdDate), diffDays = Math.round(Math.abs((currentDate.getTime() - createdDate.getTime()) / (24 * 60 * 60 * 1000)));
                if (diffDays >= 7) {
                    return IdathaLogin(res.locals.api.idatha, vcc)
                        .then(function (result) {
                        objData.accessToken = result;
                        return objData;
                    })
                        .catch(function (err) {
                        return Promise.reject(err);
                    });
                }
                else {
                    objData.accessToken = resultUserAccessTokenByRealm.accessToken;
                    return objData;
                }
            }
            else if (resultUserAccessTokenByRealm.isSystem) {
                return Promise.resolve({ name: objData.name, isSystem: true });
            }
            else if (resultUserAccessTokenByRealm.length > 0) {
                if (objData.type === 'wordcloud') {
                    return IdathaPopularWords(res.locals.api.idatha, vcc, objData.name, resultUserAccessTokenByRealm);
                }
                else if (objData.type === 'document') {
                    var fileName_1 = '';
                    fileName_1 = config_1.SEMANCTIC_ANALYSIS_VIEW_FOLDER;
                    fileName_1 += '/';
                    fileName_1 += vcc;
                    fileName_1 += '/';
                    fileName_1 += objData.id;
                    if ((objData.section && objData.section >= 0) && (objData.part && objData.part > 0)) {
                        fileName_1 += '_';
                        fileName_1 += objData.section;
                        fileName_1 += '_';
                        fileName_1 += objData.part;
                    }
                    fileName_1 += '.json';
                    logger.info('ExistInFileSystem: ', fileName_1);
                    return file_manager_1.ExistInFileSystem(fileName_1)
                        .then(function (resultExistInFileSystem) {
                        if (resultExistInFileSystem)
                            return Promise.resolve(true);
                        return IdathaDocumentWords(res.locals.api.idatha, resultUserAccessTokenByRealm, objData.id, objData.section, objData.part);
                    }).then(function (resultIdathaDocumentWords) {
                        var regex = /\bNaN\b/g;
                        var data;
                        data = JSON.stringify(resultIdathaDocumentWords.response);
                        if (regex.test(resultIdathaDocumentWords.response))
                            data = resultIdathaDocumentWords.response.replace(regex, 'null');
                        if (resultIdathaDocumentWords.response)
                            return file_manager_1.WriteFileContent(fileName_1, data, 'utf-8');
                        return Promise.resolve(true);
                    }).catch(function (err) {
                        var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
                        logger.error('Error al procesar \'' + req.path + '\': ' + errMsg);
                    });
                }
                else if (objData.type === 'createProcess') {
                    return mssql_service_1.MSSql.GetWords(vcc, 'NeuroLinguisticProgrammingId', '', 'init', objData.language)
                        .then(function (result) {
                        result.filter(function (word) { return word.neuroLinguisticProgrammingId === 'visual'; }).map(function (x) { return visual.push(x.name); });
                        result.filter(function (word) { return word.neuroLinguisticProgrammingId === 'auditive'; }).map(function (x) { return auditive.push(x.name); });
                        result.filter(function (word) { return word.neuroLinguisticProgrammingId === 'kinestesic'; }).map(function (x) { return kinestesic.push(x.name); });
                        return Promise.resolve(true);
                    }).then(function (result) {
                        return IdathaPnl(res.locals.api.idatha, resultUserAccessTokenByRealm, 'visual', visual);
                    }).then(function (result) {
                        return IdathaPnl(res.locals.api.idatha, resultUserAccessTokenByRealm, 'auditive', auditive);
                    }).then(function (result) {
                        return IdathaPnl(res.locals.api.idatha, resultUserAccessTokenByRealm, 'kinestesic', kinestesic);
                    }).then(function (result) {
                        return Promise.resolve(true);
                    });
                }
                else if (objData.type === 'query') {
                    return mssql_service_1.MSSql.GetProcess(vcc, objData.name)
                        .then(function (data) {
                        return IdathaDocumentQueryFilter(res.locals.api.idatha, resultUserAccessTokenByRealm.accessToken, objData.query, objData.from, objData.totalItems, data, objData.version);
                    }).then(function (resultIdathaDocumentQuery) {
                        return Promise.resolve(resultIdathaDocumentQuery);
                    }).then(function (result) {
                        var audios = {}, objAudios = {};
                        audios.id = [];
                        if (result.response.total_results > 0) {
                            audios.total = result.response.total_results;
                            for (var _i = 0, _a = result.response.results; _i < _a.length; _i++) {
                                var row = _a[_i];
                                audios.id.push(row.id);
                            }
                            objAudios = { ids: audios, documents: result.response };
                        }
                        else if (result.response.total_results === 0) {
                            audios.total = result.response.total_results;
                            objAudios = { ids: audios, documents: result.response };
                        }
                        return Promise.resolve(objAudios);
                    });
                }
            }
            else {
                return Promise.resolve(true);
            }
        }).then(function (objData) {
            if (objData.type === 'wordcloud') {
                return IdathaPopularWords(res.locals.api.idatha, vcc, objData.name, typeof objData.accessToken === 'string' ? objData.accessToken : objData.accessToken.accessToken);
            }
            else if (objData.type === 'document') {
                var fileName_2 = '';
                fileName_2 = config_1.SEMANCTIC_ANALYSIS_FOLDER;
                fileName_2 += '/';
                fileName_2 += vcc;
                fileName_2 += '/';
                fileName_2 += objData.id;
                if (objData.section >= 0 && objData.part > 0) {
                    fileName_2 += '_';
                    fileName_2 += objData.section;
                    fileName_2 += '_';
                    fileName_2 += objData.part;
                }
                fileName_2 += '.json';
                logger.info('ExistInFileSystem:', fileName_2);
                return file_manager_1.ExistInFileSystem(fileName_2)
                    .then(function (resultExistInFileSystem) {
                    if (resultExistInFileSystem)
                        return Promise.resolve(true);
                    return IdathaDocumentWords(res.locals.api.idatha, objData.accessToken, objData.id, objData.section, objData.part);
                }).then(function (resultIdathaDocumentWords) {
                    logger.info('resultIdathaDocumentWords: ', resultIdathaDocumentWords);
                    var regex = /\bNaN\b/g;
                    var data;
                    data = JSON.stringify(resultIdathaDocumentWords.response);
                    if (regex.test(resultIdathaDocumentWords.response))
                        data = resultIdathaDocumentWords.response.replace(regex, 'null');
                    if (resultIdathaDocumentWords.response)
                        return file_manager_1.WriteFileContent(fileName_2, data, 'utf-8');
                    return Promise.resolve(true);
                }).catch(function (err) {
                    var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
                    logger.error('Error al procesar \'' + req.path + '\': ' + errMsg);
                });
            }
            else if (objData.type === 'pnl') {
                var wordsSend_1 = [];
                words.map(function (x) { return wordsSend_1.push(x.name); });
                var wordsDeletedSend_1 = [];
                wordsDeleted.map(function (x) { return wordsDeletedSend_1.push(x.name); });
                var wordsTotal = [];
                wordsTotal = wordsSend_1.concat(wordsDeletedSend_1);
                return IdathaDeletePnl(res.locals.api.idatha, objData.accessToken, wordsTotal)
                    .then(function (result) {
                    return IdathaPnl(res.locals.api.idatha, objData.accessToken, objData.neuroLinguisticProgrammingId, wordsSend_1);
                }).then(function (result) {
                    return Promise.resolve(true);
                });
            }
            else if (objData.type === 'query') {
                return mssql_service_1.MSSql.GetProcess(vcc, objData.name)
                    .then(function (data) {
                    return IdathaDocumentQueryFilter(res.locals.api.idatha, objData.accessToken, objData.query, objData.from, objData.totalItems, data);
                }).then(function (resultIdathaDocumentQuery) {
                    return Promise.resolve(resultIdathaDocumentQuery);
                }).then(function (result) {
                    var audios = {}, objAudios = {};
                    audios.id = [];
                    if (result.response.total_results > 0) {
                        audios.total = result.response.total_results;
                        for (var _i = 0, _a = result.response.results; _i < _a.length; _i++) {
                            var row = _a[_i];
                            audios.id.push(row.id);
                        }
                        objAudios = { ids: audios, documents: result.response };
                    }
                    else if (result.response.total_results === 0) {
                        audios.total = result.response.total_results;
                        objAudios = { ids: audios, documents: result.response };
                    }
                    return Promise.resolve(objAudios);
                });
            }
            else if (objData.type === 'study') {
                (function () {
                    var vccTemp = '';
                    var themeItems = null;
                    var themeModels = null;
                    var processAudios = null;
                    logger.info('objData: ', objData);
                    return mssql_service_1.MSSql.GetTemplateThemeItems('system', objData.study.templateId, null)
                        .then(function (result) {
                        logger.info('MSSql.GetTemplateThemeItems: ', result);
                        if (result && result.length > 0) {
                            vccTemp = 'system';
                            return result;
                        }
                        vccTemp = vcc;
                        return mssql_service_1.MSSql.GetTemplateThemeItems(vcc, objData.study.templateId, null);
                    })
                        .then(function (resultGetTemplateThemeItems) {
                        logger.info('resultGetTemplateThemeItems: ', resultGetTemplateThemeItems);
                        if (resultGetTemplateThemeItems && resultGetTemplateThemeItems.length > 0) {
                            themeItems = resultGetTemplateThemeItems;
                            var index_1 = 0, from_1 = 0, size_1 = 15, times_1 = 0, page_1 = 1;
                            objData.template = objData.study.templateId;
                            return mssql_service_1.MSSql.GetProcess(vcc, objData.name)
                                .then(function (result) {
                                logger.info('MSSql.GetProcess - result: ', result);
                                return Promise.resolve(exports.RecursiveRequestQueryFilter(vcc, objData, userId, res.locals.api.idatha, objData.accessToken, themeItems, index_1, from_1, size_1, times_1, [], page_1, result));
                            });
                        }
                        else {
                            var result = { status: false, content: 'NO_QUERY_FOR_STUDY_TEMPLATE' };
                            return Promise.resolve(result);
                        }
                    })
                        .then(function (studyResults) {
                        logger.info('studyResults: ', studyResults);
                        if (studyResults.status === false) {
                            return Promise.resolve(studyResults);
                        }
                        else {
                            var len = studyResults.idathaArray.length, obj, themeItem, finalResult, lenResults, objResult, i, j, finalResults = [], SQL = '';
                            for (i = 0; i < len; i++) {
                                obj = studyResults.idathaArray[i];
                                themeItem = themeItems.find(function (x) {
                                    return x.id === obj.id;
                                });
                                if (themeItem) {
                                    finalResult = finalResults.find(function (x) {
                                        return x.templateThemeItemId === themeItem.id;
                                    });
                                    if (finalResult) {
                                        lenResults = obj.result.response.results.length;
                                        for (j = 0; j < lenResults; j++) {
                                            objResult = obj.result.response.results[j];
                                            finalResult.results.push(objResult);
                                        }
                                    }
                                    else {
                                        finalResults.push({
                                            templateId: obj.templateId,
                                            templateThemeId: obj.templateThemeId,
                                            templateThemeItemId: obj.id,
                                            results: obj.result.response.results
                                        });
                                    }
                                }
                            }
                            len = finalResults.length;
                            for (i = 0; i < len; i++) {
                                obj = finalResults[i];
                                SQL += saveStudyResultSummaryDetail(vcc, studyResults.studyId, userId, obj);
                            }
                            finalResults = getUniqueFinalResults(finalResults);
                            len = finalResults.length;
                            for (i = 0; i < len; i++) {
                                obj = finalResults[i];
                                SQL += processFinalResults(vcc, studyResults.studyId, userId, obj);
                            }
                            return Promise.resolve(SQL);
                        }
                    })
                        .then(function (sqlResult) {
                        if (sqlResult.status === false) {
                            return Promise.resolve(sqlResult);
                        }
                        else {
                            return mssql_service_1.MSSql.SaveSQLStudyDetail(vcc, objData.study.studyId, objData.study.templateId, sqlResult, objData.study.restart);
                        }
                    })
                        .then(function (result) {
                        logger.info('MSSql.SaveSQLStudyDetail - result: ', vcc, objData.study.studyId, objData.study.templateId);
                        var vccTemp = '';
                        var themeItems = null;
                        return mssql_service_1.MSSql.GetTemplateThemeModels('system', objData.study.templateId, null)
                            .then(function (result) {
                            logger.info('MSSql.GetTemplateThemeModels - result - system : ', result);
                            if (result && result.length > 0) {
                                vccTemp = 'system';
                                return result;
                            }
                            vccTemp = vcc;
                            return mssql_service_1.MSSql.GetTemplateThemeModels(vcc, objData.study.templateId, null);
                        });
                    }).then(function (resultGetTemplateThemeModels) {
                        themeModels = resultGetTemplateThemeModels;
                        logger.info('themeModels', JSON.stringify(themeModels));
                        if (themeModels && themeModels.length > 0) {
                            return mssql_service_1.MSSql.GetProcessAudios(vcc, objData.study.processId)
                                .then(function (resultGetProcessAudios) {
                                var promiseArray = [];
                                logger.info('resultGetProcessAudios: ', resultGetProcessAudios);
                                if (resultGetProcessAudios && resultGetProcessAudios.length) {
                                    var results_1 = [];
                                    return resultGetProcessAudios.reduce(function (promise, resultGetProcessAudio) {
                                        return promise.then(function (result) {
                                            return GetQueryModel(vcc, cognitiveService, res.locals.api.idatha, objData.accessToken, resultGetProcessAudio, themeModels, azure.subscriptionRegion, azure.subscriptionKey).then(function (result) { return results_1.push(result); });
                                        });
                                    }, Promise.resolve())
                                        .then(function () {
                                        return results_1;
                                    })
                                        .then(function (results) {
                                        logger.info('GetQueryModel - QueryLUIS: ', JSON.stringify(results));
                                        logger.info('themeModels: ', JSON.stringify(themeModels));
                                        var flatteningDataResult = nlu.flatteningData(results, themeModels);
                                        logger.info('flatteningDataResult: ', JSON.stringify(flatteningDataResult));
                                        return Promise.resolve(flatteningDataResult);
                                    })
                                        .then(function (flatteningDataResult) {
                                        if (flatteningDataResult && flatteningDataResult.length > 0) {
                                            var SQL = nlu.setInput(vcc, objData.study.studyId, userId, flatteningDataResult, themeModels);
                                            logger.info('SQL Input Study: ', SQL);
                                            return Promise.resolve(SQL);
                                        }
                                        else {
                                            return Promise.resolve('NO_DATA_STUDY_NLU');
                                        }
                                    });
                                }
                                else {
                                    return null;
                                }
                            })
                                .then(function (sqlResult) {
                                logger.info('sqlResult SQL Input Study: ', sqlResult);
                                if (sqlResult !== 'NO_DATA_STUDY_NLU') {
                                    return mssql_service_1.MSSql.SaveSQLStudyDetail(vcc, objData.study.studyId, objData.study.templateId, sqlResult, objData.study.restart);
                                }
                                else {
                                    return Promise.resolve(sqlResult);
                                }
                            })
                                .then(function (sqlResult) {
                                logger.info('sqlResult: ', sqlResult);
                                if (sqlResult === 'NO_DATA_STUDY_NLU') {
                                    return Promise.resolve(sqlResult);
                                }
                                else {
                                    return Promise.resolve(true);
                                }
                            }).catch(function (err) {
                                var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
                                var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
                                res.json({ status: false, description: clientMsg, error: errorMsg, detail: { type: 'ERROR', datetime: moment().utc().toDate(), pid: process.pid, source: __filename, stack: err.stack } });
                            });
                        }
                        else {
                            return Promise.resolve(true);
                        }
                    });
                }());
                return Promise.resolve(true);
            }
            else if (objData.type === 'status') {
                return IdathaStatus(res.locals.api.idatha, objData.accessToken)
                    .then(function (result) {
                    return Promise.resolve(result);
                })
                    .catch(function (err) {
                    var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
                    var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
                    res.json({ status: false, description: clientMsg, error: errorMsg, detail: { type: 'ERROR', datetime: moment().utc().toDate(), pid: process.pid, source: __filename, stack: err.stack } });
                });
            }
            else if (objData.type === 'createProcess') {
                return mssql_service_1.MSSql.GetWords(vcc, 'NeuroLinguisticProgrammingId', '', 'init', objData.language)
                    .then(function (result) {
                    result.filter(function (word) { return word.neuroLinguisticProgrammingId === 'visual'; }).map(function (x) { return visual.push(x.name); });
                    result.filter(function (word) { return word.neuroLinguisticProgrammingId === 'auditive'; }).map(function (x) { return auditive.push(x.name); });
                    result.filter(function (word) { return word.neuroLinguisticProgrammingId === 'kinestesic'; }).map(function (x) { return kinestesic.push(x.name); });
                    return Promise.resolve(true);
                }).then(function (result) {
                    return IdathaPnl(res.locals.api.idatha, objData.accessToken, 'visual', visual);
                }).then(function (result) {
                    return IdathaPnl(res.locals.api.idatha, objData.accessToken, 'auditive', auditive);
                }).then(function (result) {
                    return IdathaPnl(res.locals.api.idatha, objData.accessToken, 'kinestesic', kinestesic);
                }).then(function (result) {
                    return Promise.resolve(true);
                })
                    .then(function (result) {
                    console.log(425, result);
                });
            }
            else if (objData) {
                return Promise.resolve(true);
            }
        })
            .then(function (result) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'OK', data: result });
        })
            .catch(function (err) {
            var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: clientMsg, error: errorMsg });
        });
    });
}
exports.IdathaService = IdathaService;
function IdathaRegisterCaller(vcc, idathaIP, idathaPort) {
    return __awaiter(this, void 0, void 0, function () {
        var auth;
        return __generator(this, function (_a) {
            auth = {
                userName: config_1.REALM_USER_NAME,
                password: config_1.REALM_PASSWORD,
                realm: vcc,
                vcc: vcc
            };
            return [2, CreateIdathaRealm(auth, idathaIP, idathaPort)];
        });
    });
}
exports.IdathaRegisterCaller = IdathaRegisterCaller;
function CreateIdathaRealm(idathaAuth, idathaIP, idathaPort) {
    var userSystem = 'system';
    return promises_shared_1.DummyPromise().then(function (_) {
        return mssql_service_1.MSSql.GetIdathaAuthByRealm(userSystem, userSystem);
    }).then(function (_a) {
        var password = _a.password;
        console.log(password);
        return mssql_service_1.MSSql.GetUserAccessTokenByRealm(userSystem, userSystem);
    }).then(function (result) {
        console.log(result);
        if (result && result.accessToken) {
            var currentDate = new Date(), createdDate = new Date(result.createdDate);
            var diffDays = Math.round(Math.abs((currentDate.getTime() - createdDate.getTime()) / (24 * 60 * 60 * 1000)));
            if (diffDays >= 7) {
                return IdathaLogin({
                    ip: idathaIP,
                    httpPort: idathaPort
                }, userSystem);
            }
            return result.accessToken;
        }
        return '';
    }).then(function (accessToken) {
        var options = {
            method: 'POST',
            uri: 'http://' + idathaIP + ':' + idathaPort + '/api/auth/register',
            headers: {
                'Authorization': 'Bearer ' + accessToken
            },
            body: idathaAuth,
            json: true,
            resolveWithFullResponse: false
        };
        return request(options);
    }).then(function (r) {
        console.log("req", r);
        return mssql_service_1.MSSql.SaveIdathaAuth(idathaAuth.vcc, idathaAuth.userName, idathaAuth.password, idathaAuth.realm);
    }).then(function (r) {
        console.log("r", r);
    })
        .catch(function (err) {
        var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
        var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error al procesar \'' + err + '\': ' + errorMsg);
        if (errorMsg === '500 - {"message":"Username already exists"}') {
            mssql_service_1.MSSql.SaveIdathaAuth(idathaAuth.vcc, idathaAuth.userName, idathaAuth.password, idathaAuth.realm);
        }
    });
}
exports.CreateIdathaRealm = CreateIdathaRealm;
function CreateIdathaRealmDirs(idatha, realm, vcc) {
    console.log('Envía a la creación de la carpeta de acuerdo al nombre.');
    return IdathaCreateFolder(idatha, realm).then(function (result) {
        console.log('Obtiene resultado luego de la creación de la carpeta: ', result);
        return IdathaLogin(idatha, vcc);
    });
}
exports.CreateIdathaRealmDirs = CreateIdathaRealmDirs;
function IdathaRegister(idatha, idathaAuth) {
    var userSystem = 'system', password = '';
    return mssql_service_1.MSSql.GetIdathaAuthByRealm(userSystem, userSystem)
        .then(function (result) {
        password = result.password;
        return mssql_service_1.MSSql.GetUserAccessTokenByRealm(userSystem, userSystem);
    }).then(function (resultUserAccessTokenByRealm) {
        var accessToken = '';
        if (resultUserAccessTokenByRealm && resultUserAccessTokenByRealm.accessToken) {
            accessToken = resultUserAccessTokenByRealm.accessToken;
            var currentDate = new Date(), createdDate = new Date(resultUserAccessTokenByRealm.createdDate), diffDays = Math.round(Math.abs((currentDate.getTime() - createdDate.getTime()) / (24 * 60 * 60 * 1000)));
            if (diffDays >= 7) {
                return IdathaLogin(idatha, userSystem);
            }
        }
        return accessToken;
    }).then(function (accessToken) {
        console.log('Obtiene token de system: ', accessToken);
        console.log(idathaAuth);
        var options = {
            method: 'POST',
            uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/auth/register',
            headers: {
                'Authorization': 'Bearer ' + accessToken
            },
            body: {
                username: idathaAuth.userName,
                password: idathaAuth.password,
                realm: idathaAuth.realm
            },
            json: true,
            resolveWithFullResponse: false
        };
        console.log(515, options);
        return request(options)
            .then(function (response) {
            console.log('Obtiene respuesta de la creación del nuevo realm: ', response);
            return mssql_service_1.MSSql.SaveIdathaAuth(idathaAuth.vcc, idathaAuth.userName, idathaAuth.password, idathaAuth.realm)
                .then(function (response) {
                console.log('Envía a la creación de la carpeta de acuerdo al nombre.');
                return IdathaCreateFolder(idatha, idathaAuth.realm).then(function (result) {
                    console.log('Obtiene resultado luego de la creación de la carpeta: ', result);
                    return IdathaLogin(idatha, idathaAuth.vcc);
                });
            })
                .catch(function (err) {
                return Promise.reject(err);
            });
        }).catch(function (err) {
            var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
            logger.error('Error al procesar \'' + err + '\': ' + errorMsg);
            if (errorMsg === '500 - {"message":"Username already exists"}') {
                return mssql_service_1.MSSql.SaveIdathaAuth(idathaAuth.vcc, idathaAuth.userName, idathaAuth.password, idathaAuth.realm)
                    .then(function (response) {
                    console.log('Envía a la creación de la carpeta de acuerdo al nombre.');
                    return IdathaCreateFolder(idatha, idathaAuth.realm).then(function (result) {
                        console.log('Obtiene resultado luego de la creación de la carpeta: ', result);
                        return IdathaLogin(idatha, idathaAuth.vcc);
                    });
                })
                    .catch(function (err) {
                    return Promise.reject(err);
                });
            }
            return Promise.resolve(false);
        });
    });
}
exports.IdathaRegister = IdathaRegister;
function IdathaCreateFolder(idatha, folder) {
    logger.info('Se envía a crear una carpeta con nombre ' + folder + ' en un directorio del servidor de IDATHA.');
    var ssh = new NodeSSH();
    return ssh.connect({
        host: idatha.ip,
        username: idatha.user,
        password: idatha.password,
        port: idatha.sshPort,
        readyTimeout: 99999
    }).then(function () {
        var cmd = 'mkdir -p ';
        cmd += folder.toLowerCase();
        cmd += '/default';
        ssh.execCommand(cmd, { cwd: '/home/admon/in_concert_speech_analytics/input' }).then(function (x) {
            console.log(984, x);
        });
    }).catch(function (error) {
        console.log(error);
        logger.error('Ha sucedido el error: ' + error.message);
    });
}
exports.IdathaCreateFolder = IdathaCreateFolder;
function IdathaSendJSONFiles(idatha, processId, realmName) {
    console.log(569, idatha, processId, realmName);
    logger.info('Se envía a copiar documentos de archivos JSON para el realm ' + realmName);
    logger.info(config_1.PATH_FOLDER_PROCESS_AUDIO + '/' + processId + '/speechmatics/', idatha.user + ':' + idatha.password + '@' + idatha.ip + ':' + idatha.sshPort + ':/home/' + idatha.user + '/in_concert_speech_analytics/input/' + realmName.toLowerCase() + '/default/');
    return new Promise(function (resolve, reject) {
        try {
            scp2.scp(config_1.PATH_FOLDER_PROCESS_AUDIO + '/' + processId + '/speechmatics/', idatha.user + ':' + idatha.password + '@' + idatha.ip + ':' + idatha.sshPort + ':/home/' + idatha.user + '/in_concert_speech_analytics/input/' + realmName.toLowerCase() + '/default/', function (err) {
                console.log(598, err);
                resolve(err === null || err === undefined);
            });
        }
        catch (e) {
            reject(e);
        }
    });
}
exports.IdathaSendJSONFiles = IdathaSendJSONFiles;
function IdathaLogin(idatha, vcc, devMode) {
    if (devMode === void 0) { devMode = false; }
    var accessToken = null;
    var idathaAuth = null;
    return promises_shared_1.DummyPromise()
        .then(function (result) {
        var key = vcc + ':' + vcc;
        return redis_service_1.Redis.GetUserAccessTokenByRealm(key);
    })
        .then(function (result) {
        if (result && result.accessToken) {
            accessToken = result;
            var currentDate = parseInt(moment().format('x'));
            var createdDate = parseInt(result.createdDate);
            var diffDays = Math.round(Math.abs((currentDate - createdDate) / (24 * 60 * 60 * 1000)));
            if (diffDays >= 6) {
                if (devMode) {
                    return new idatha_model_1.IdathaAuth(vcc, config_1.REALM_USER_NAME, config_1.REALM_PASSWORD, vcc);
                }
                return mssql_service_1.MSSql.GetIdathaAuthByRealm(vcc, vcc);
            }
            else {
                return null;
            }
        }
        else {
            if (devMode) {
                return new idatha_model_1.IdathaAuth(vcc, config_1.REALM_USER_NAME, config_1.REALM_PASSWORD, vcc);
            }
            return mssql_service_1.MSSql.GetIdathaAuthByRealm(vcc, vcc);
        }
    })
        .then(function (auth) {
        if (auth) {
            idathaAuth = auth;
            var options = {
                method: 'POST',
                uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/auth/login',
                body: {
                    username: idathaAuth.userName,
                    password: idathaAuth.password,
                    realm: vcc === 'system' ? '' : idathaAuth.realm
                },
                json: true,
                resolveWithFullResponse: false
            };
            return request(options);
        }
        else
            return null;
    })
        .then(function (result) {
        if (result && result.access_token) {
            var promiseArray = [];
            var nowUtc = moment().utc().toDate();
            accessToken = result.access_token;
            promiseArray.push(mssql_service_1.MSSql.SaveUserAccessToken(vcc, idathaAuth.userName, accessToken, idathaAuth.realm, nowUtc));
            var userAcessToken = {};
            userAcessToken.accessToken = accessToken;
            userAcessToken.createdDate = moment().format('x');
            var key = idathaAuth.vcc + ':' + idathaAuth.vcc;
            promiseArray.push(redis_service_1.Redis.SaveUserAccessTokenByRealm(key, userAcessToken));
            return Promise.all(promiseArray);
        }
        else {
            return null;
        }
    })
        .then(function (response) {
        return Promise.resolve(accessToken);
    })
        .catch(function (err) {
        return Promise.reject(err);
    });
}
exports.IdathaLogin = IdathaLogin;
function IdathaPopularWords(idatha, vcc, processId, accessToken) {
    var options = {
        method: 'GET',
        uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/query/conversation/popular_words',
        headers: {
            'Authorization': 'Bearer ' + accessToken
        },
        json: true,
        resolveWithFullResponse: false
    };
    return request(options)
        .then(function (response) {
        var content = { type: 'popularwords' }, popularWords = response.aggregations.words.popular_words.buckets;
        if (popularWords && popularWords.length > 0) {
            var tags_1 = popularWords.map(function (x) {
                return {
                    tags: (function (x) {
                        return x.words.buckets.map(function (y) {
                            return {
                                key: y.key,
                                value: y.doc_count
                            };
                        });
                    }(x)),
                    type: x.key
                };
            });
            return mssql_service_1.MSSql.GetExceptions(vcc, null, null).then(function (exceptions) {
                if (exceptions.length > 0) {
                    tags_1 = tags_1.map(function (x) {
                        return {
                            tags: (function (x) {
                                return x.tags = x.tags.filter(function (y) {
                                    return !exceptions.find(function (exception) {
                                        return y.key.toLowerCase() === exception.description.toLowerCase();
                                    });
                                });
                            }(x)),
                            type: x.type
                        };
                    });
                }
                tags_1 = tags_1.map(function (x) {
                    return (function () {
                        x.tags = x.tags.sort(function (a, b) {
                            return b.value - a.value;
                        });
                        x.tags.length = (x.tags.length < 20 ? x.tags.length : 20);
                        return x;
                    }());
                });
                content.tags = tags_1;
                return content.tags;
            });
        }
    })
        .catch(function (err) {
        logger.error('[IdathaService::IdathaPopularWords] Getting error:', err, 'idatha:', idatha, 'processId:', processId, 'accessToken:', accessToken);
        return Promise.reject(err);
    });
}
exports.IdathaPopularWords = IdathaPopularWords;
function IdathaDocumentWords(idatha, accessToken, audioId, section, part) {
    var url = 'http://';
    url += idatha.ip;
    url += ':';
    url += idatha.httpPort;
    url += '/api/query/document/';
    url += audioId;
    if ((section && section >= 0) && (part && part > 0)) {
        url += '_';
        url += section;
        url += '_';
        url += part;
    }
    var options = {
        method: 'GET',
        uri: url,
        headers: {
            'Authorization': 'Bearer ' + accessToken
        },
        json: true,
        resolveWithFullResponse: false
    };
    logger.info('IdathaDocumentWords - options: ', options);
    return request(options)
        .then(function (response) {
        var content = { response: response, type: 'document' };
        logger.info('content: ', content);
        return Promise.resolve(content);
    }).catch(function (err) {
        options = {
            method: 'GET',
            uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/query/document/' + audioId,
            headers: {
                'Authorization': 'Bearer ' + accessToken
            },
            json: true,
            resolveWithFullResponse: false
        };
        logger.info('IdathaDocumentWords - options - catch: ', options);
        return request(options)
            .then(function (response) {
            var content = { response: response, type: 'document' };
            return Promise.resolve(content);
        }).catch(function (err) {
            logger.error('Ha sucedido el error: ' + err.message);
            return Promise.reject(err);
        });
    });
}
exports.IdathaDocumentWords = IdathaDocumentWords;
function IdathaPnl(idatha, accessToken, kind, words) {
    var options = {
        method: 'POST',
        uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/pnl/words',
        body: {
            kind: kind,
            words: words
        },
        headers: {
            'Authorization': 'Bearer ' + accessToken
        },
        json: true,
        resolveWithFullResponse: false
    };
    return request(options)
        .then(function (response) {
        var content = { response: response, type: 'pnl' };
        return Promise.resolve(content);
    }).catch(function (err) {
        return Promise.reject(err);
    });
}
exports.IdathaPnl = IdathaPnl;
function IdathaDeletePnl(idatha, accessToken, words) {
    var options = {
        method: 'DELETE',
        uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/pnl/words',
        body: {
            words: words
        },
        headers: {
            'Authorization': 'Bearer ' + accessToken
        },
        json: true,
        resolveWithFullResponse: false
    };
    return request(options)
        .then(function (response) {
        var content = { response: response, type: 'deletePnl' };
        return Promise.resolve(content);
    }).catch(function (err) {
        return Promise.reject(err);
    });
}
exports.IdathaDeletePnl = IdathaDeletePnl;
function IdathaDocumentQueryFilter(idatha, accessToken, query, from, size, process, version) {
    if (version === void 0) { version = 1; }
    var body = null;
    var queryDataId = '';
    var currentDate = new Date();
    var queryDataIdDate = new Date(process.queryDataIdDate);
    var diffDays = Math.round(Math.abs((currentDate.getTime() - queryDataIdDate.getTime()) / (24 * 60 * 60 * 1000)));
    logger.info('diffDays: ', diffDays);
    if (diffDays >= config_1.IDATHA_QUERY_ID_EXPIRATION) {
        var queryProcess = semantic_query_implementation_1.GetQueryIdathaProcessV2(process.processFilters);
        logger.info('(IdathaDocumentQueryFilter) query_data_id caducó. Se envía consulta con filtros del proceso ' + process.name + ' ' + queryProcess);
        body = {
            query: queryProcess,
            from: from,
            size: 2,
            version: 2
        };
        logger.info('request con filter_data: ', body);
    }
    else {
        logger.info('(IdathaDocumentQueryFilter) query_data_id vigente. Hacemos la consulta con query_data_id : ' + process.name + ' ' + query);
        body = {
            query_id: process.queryDataId,
            query: query,
            from: from,
            size: size,
            version: version
        };
        logger.info('request con query_id: ', body);
    }
    var options = {
        method: 'POST',
        uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/query',
        body: body,
        headers: {
            'Authorization': 'Bearer ' + accessToken
        },
        json: true,
        resolveWithFullResponse: false
    };
    return request(options)
        .then(function (response) {
        logger.info('total resultados filterdata: ', response.total_results);
        var content = { response: response, type: 'documentQuery' };
        if (diffDays >= config_1.IDATHA_QUERY_ID_EXPIRATION) {
            queryDataId = response.query_id;
            return mssql_service_1.MSSql.SaveProcess(process.vcc, process.name, process.description, process.clientId, process.status, process.type, process.startDate, process.endDate, process.minDurationTime, process.maxDurationTime, process.language, process.dictionaryId, process.environment, process.queryId, queryDataId, moment().utc().toDate(), process.createdDate, process.createdByUserId, process.lastModifiedDate, process.lastModifiedByUserId).then(function (result) {
                var body = {
                    query_id: queryDataId,
                    query: query,
                    from: from,
                    size: size
                };
                var options = {
                    method: 'POST',
                    uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/query',
                    body: body,
                    headers: {
                        'Authorization': 'Bearer ' + accessToken
                    },
                    json: true,
                    resolveWithFullResponse: false
                };
                logger.info('Proceso ' + process.name + ' ');
                logger.info('request con query_id: ', body);
                return request(options);
            }).then(function (response) {
                logger.info('total resultados filterdata con query: ', response.total_results);
                var content = { response: response, type: 'documentQuery' };
                return Promise.resolve(content);
            }).catch(function (err) {
                console.log('Error: ', err);
                var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
                logger.error('Error en IdathaDocumentQueryFilter: ' + process.name + ' ' + query + ' ' + errorMsg);
                return Promise.reject(err);
            });
        }
        else {
            logger.info('Se envía petición ' + options.method + ' a ' + options.uri + ' con query: ' + query + ' desde ' + from + ' hasta ' + size);
            return Promise.resolve(content);
        }
    }).catch(function (err) {
        console.log("Falló consulta idatha:", body);
        console.log('Error: ', err);
        var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error en IdathaDocumentQueryFilter: ' + process.name + ' ' + query + ' ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.IdathaDocumentQueryFilter = IdathaDocumentQueryFilter;
function IdathaStatus(idatha, accessToken) {
    var options = {
        method: 'GET',
        uri: 'http://' + idatha.ip + ':' + idatha.httpPort + '/api/admin/status',
        headers: {
            'Authorization': 'Bearer ' + accessToken
        },
        json: true,
        resolveWithFullResponse: false
    };
    return request(options)
        .then(function (response) {
        var content = { response: response, type: 'status' };
        return Promise.resolve(content);
    }).catch(function (err) {
        console.log('Error: ', err);
        var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error en la consulta IDATHA: ' + '\': ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.IdathaStatus = IdathaStatus;
function UpdateStudyStatus(vcc, objData, status, id, errorMessage, lastModifiedDate, userId) {
    return mssql_service_1.MSSql.SaveStudyStatus(vcc, objData.study.processId, objData.template, objData.study.studyId, status.percentage, id, errorMessage, lastModifiedDate, userId)
        .then(function (resultSaveStudyStatus) {
        console.log('Respuesta correcta, se actualizó...', 'resultSaveStudyStatus', resultSaveStudyStatus);
        return Promise.resolve(resultSaveStudyStatus);
    })
        .catch(function (err) {
        var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error al intentar actualizar el estado del estudio: ' + '\': ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.UpdateStudyStatus = UpdateStudyStatus;
function GetQueryModel(vcc, cognitiveService, idatha, accessToken, processAudios, themeModels, subscriptionRegion, subscriptionKey) {
    var arrayIntents = [];
    var modelsLUIS = [];
    var arrayQueries = [];
    var section = processAudios.section;
    section = section * 1;
    var part = processAudios.part;
    part = part * 1;
    return IdathaDocumentWords(idatha, accessToken, processAudios.audioId, section, part)
        .then(function (result) {
        var transcription = SortJson(result.response);
        logger.info('transcription: ', transcription);
        var phrases = nlu.validate(transcription);
        logger.info('phrases: ', phrases);
        return Promise.resolve(phrases);
    }).then(function (resultArray500) {
        arrayQueries = resultArray500;
        logger.info('arrayQueries: ', arrayQueries);
        var models = [];
        for (var _i = 0, themeModels_1 = themeModels; _i < themeModels_1.length; _i++) {
            var row = themeModels_1[_i];
            models.push(row.query.split('|')[0]);
        }
        models = uniqueNLU(models);
        logger.info('models: ', models);
        return mssql_service_1.MSSql.GetNLUsStudy(vcc, null, null, models.join('\',\''));
    }).then(function (result) {
        modelsLUIS = result;
        console.log('modelsLUIS', JSON.stringify(modelsLUIS));
        var promiseArray = [];
        if (arrayQueries && arrayQueries.length) {
            var timeOut_1 = 0;
            arrayQueries.forEach(function (query, index) {
                timeOut_1 = index * Math.ceil(modelsLUIS.length / 5);
                logger.info('QueryLUIS: ', timeOut_1, index, query.content, processAudios.audioId, processAudios.section, processAudios.part);
                promiseArray.push(new Promise(function (resolve, reject) {
                    setTimeout(QueryLUIS, timeOut_1, cognitiveService, query.content, modelsLUIS, subscriptionRegion, subscriptionKey, processAudios, resolve);
                }));
            });
        }
        return Promise.all(promiseArray)
            .then(function (results) {
            logger.info('QueryLUIS - promiseArray - results: ', JSON.stringify(results));
            return Promise.resolve(results);
        })
            .then(function (results) {
            logger.info('QueryLUIS - promiseArray - results- GetQueryModel: ', JSON.stringify(results));
            return Promise.resolve(results);
        })
            .catch(function (err) {
            logger.error('QueryLUIS - promiseArray - error- GetQueryModel: ', err);
            return Promise.reject(err);
        });
    }).then(function (results) {
        logger.info('result - 1226: ', JSON.stringify(results));
        return Promise.resolve(results);
    }).catch(function (err) {
        logger.error('GetQueryModel - err: ' + err.message);
        return Promise.resolve(err);
    });
}
function uniqueNLU(models) {
    var result = [], i, len = models.length, model, index = -1;
    for (i = 0; i < len; i++) {
        model = models[i];
        index = result.findIndex(function (x) {
            return x === model;
        });
        if (index === -1) {
            result.push(model);
        }
    }
    return result;
}
function QueryLUIS(cognitiveService, query, nlus, subscriptionRegion, subscriptionKey, processAudios, resolve) {
    var promiseArray = [];
    if (nlus && nlus.length) {
        var timeOut_2 = 0;
        logger.info('nlus: ', nlus);
        nlus.forEach(function (nlu, index) {
            timeOut_2 = index % 3 === 0 ? index * 1000 : timeOut_2;
            logger.info('timeOut: ', timeOut_2, index, nlu.appId, query, processAudios.audioId, processAudios.section, processAudios.part);
            promiseArray.push(new Promise(function (resolve, reject) {
                setTimeout(cognitiveService.ModelQuery, timeOut_2, subscriptionRegion, subscriptionKey, nlu.appId, query, processAudios, nlu.name, resolve);
            }));
        });
    }
    return Promise.all(promiseArray).then(function (results) {
        logger.info('cognitiveService.ModelQuery - results: ', JSON.stringify(results));
        console.log('result - luis: \n');
        return Promise.resolve(results);
    })
        .then(function (maxIntentData) {
        logger.info('QueryLUIS - maxIntentData - Promise.all: ', JSON.stringify(maxIntentData));
        return resolve ? resolve(maxIntentData) : Promise.resolve(maxIntentData);
    })
        .catch(function (err) {
        logger.info('QueryLUIS - error - Promise.all: ', err);
        return Promise.reject(err);
    });
}
function SortJson(jsonobj) {
    var outlength;
    var inlength;
    var i;
    var audioInit;
    var obj = {};
    obj.transcription = [];
    obj.summarySpeechData = {};
    obj.confidence = {};
    obj.init = '';
    var json = jsonobj;
    audioInit = json.words[0].speaker;
    obj.init = audioInit;
    obj.nlp = {};
    outlength = json.out_sentences.length;
    inlength = json.in_sentences.length;
    if (outlength >= inlength) {
        for (i in json.out_sentences) {
            if (i < inlength && inlength > 0) {
                if (audioInit === 'out' && inlength > 0) {
                    obj.transcription.push({
                        out: json.out_sentences[i].text,
                        in: json.in_sentences[i] === 'undefined' ? '' : json.in_sentences[i].text
                    });
                }
                else if (audioInit === 'in' && inlength > 0) {
                    obj.transcription.push({
                        in: json.in_sentences[i].text,
                        out: json.out_sentences[i].text
                    });
                }
            }
            else {
                if (audioInit === 'out' && inlength >= 0) {
                    obj.transcription.push({
                        out: json.out_sentences[i] === undefined ? '' : json.out_sentences[i].text,
                        in: ''
                    });
                }
                else if (audioInit === 'in' && inlength >= 0) {
                    obj.transcription.push({
                        in: '',
                        out: json.out_sentences[i] === undefined ? '' : json.out_sentences[i].text
                    });
                }
            }
        }
    }
    else if (outlength <= inlength) {
        for (i in json.in_sentences) {
            if (i < outlength && outlength > 0) {
                if (audioInit === 'out' && outlength > 0) {
                    obj.transcription.push({
                        out: json.out_sentences[i].text,
                        in: json.in_sentences[i].text
                    });
                }
                else if (audioInit === 'in' && outlength > 0) {
                    obj.transcription.push({
                        in: json.in_sentences[i].text,
                        out: json.out_sentences[i].text
                    });
                }
            }
            else {
                if (audioInit === 'out' && inlength >= 0) {
                    obj.transcription.push({
                        out: '',
                        in: json.in_sentences[i] === undefined ? '' : json.in_sentences[i].text,
                    });
                }
                else if (audioInit === 'in' && inlength >= 0) {
                    obj.transcription.push({
                        in: json.in_sentences[i] === undefined ? '' : json.in_sentences[i].text,
                        out: ''
                    });
                }
            }
        }
    }
    return obj;
}
exports.RecursiveRequestQueryFilter = function (vcc, objData, userId, idatha, accessToken, themeItems, themeItemIndex, from, size, times, idathaArray, page, process) {
    if (idathaArray === void 0) { idathaArray = []; }
    var objResult = {
        studyId: objData.study.studyId,
        idathaArray: idathaArray
    };
    var lastModifiedDate = moment().utc().toDate();
    var status = getPercentage(themeItems, themeItems[themeItemIndex].id);
    return UpdateStudyStatus(vcc, objData, status, themeItems[themeItemIndex].id, '', lastModifiedDate, userId)
        .then(function (resultUpdateStudyStatus) {
        return IdathaDocumentQueryFilter(idatha, accessToken, themeItems[themeItemIndex].query, from, size, process).then(function (result) {
            if (result.response.total_results > 0) {
                times = getTotalPages(result.response.total_results, size);
                console.log('RecursiveRequestQueryFilter:::: ', 'INDEX: ', themeItemIndex, themeItems[themeItemIndex].id, 'times: ', times, 'from:::: ', from, themeItems[themeItemIndex].query, result.response.total_results);
                idathaArray.push({
                    templateId: themeItems[themeItemIndex].templateId,
                    templateThemeId: themeItems[themeItemIndex].templateThemeId,
                    id: themeItems[themeItemIndex].id,
                    index: themeItemIndex,
                    query: themeItems[themeItemIndex].query,
                    from: from,
                    result: result
                });
                if (page === times) {
                    themeItemIndex++;
                    page = 1;
                    from = 0;
                }
                else {
                    from += size;
                    page++;
                }
            }
            else {
                themeItemIndex++;
                page = 1;
                from = 0;
            }
            times = 0;
            return (themeItemIndex < (themeItems && themeItems.length)) ? exports.RecursiveRequestQueryFilter(vcc, objData, userId, idatha, accessToken, themeItems, themeItemIndex, from, size, times, idathaArray, page, process) : Promise.resolve(objResult);
        }).catch(function (err) {
            console.log('Error: ', err);
            logger.error('Ha sucedido el error: ' + err.message);
            UpdateStudyStatus(vcc, objData, status, themeItems[themeItemIndex].id, err.message, lastModifiedDate, userId)
                .then(function (result) {
                logger.info('UpdateStudyStatus Error: ', result);
                return Promise.resolve(result);
            })
                .catch(function (err) {
                return Promise.reject(err);
            });
            return Promise.reject(err);
        });
    })
        .catch(function (err) {
        logger.error('UpdateStudyStatus: ' + err.message);
        return Promise.reject(err);
    });
};
function RecursiveIdathaRequest(req, res, idatha, accessToken, inserted, pending) {
    logger.info('RecursiveIdathaRequest - inserted: ', inserted, 'pending: ', pending);
    return IdathaStatus(idatha, accessToken)
        .then(function (idathaResult) {
        if (idathaResult.status === false) {
            console.log('Error');
            return Promise.resolve(0);
        }
        else {
            var status_1 = 0;
            inserted = idathaResult.response.inserted_documents;
            pending = idathaResult.response.pending_documents;
            status_1 = (inserted / (pending + inserted)) || 0;
            if (status_1 < 1) {
                return RecursiveIdathaRequest(req, res, idatha, accessToken, inserted, pending);
            }
            else {
                return Promise.resolve(status_1);
            }
        }
    })
        .catch(function (err) {
        console.log('Error: ', err);
        var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
        var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Error al ejecutar solicitud');
        logger.error('Error al procesar IdathaStatus:' + errorMsg);
    });
}
exports.RecursiveIdathaRequest = RecursiveIdathaRequest;
function getTotalPages(totalItems, itemsPerPage) {
    var totalPages = itemsPerPage < 1 ? 1 : Math.ceil(totalItems / itemsPerPage);
    return Math.max(totalPages || 0, 1);
}
exports.getTotalPages = getTotalPages;
function saveStudyResultSummaryDetail(vcc, studyId, userId, idatha) {
    var len = idatha.results.length, obj, SQL = '', i;
    for (i = 0; i < len; i++) {
        obj = idatha.results[i];
        SQL += 'INSERT INTO [dbo].[StudyResultSummaryDetail]([VCC],[StudyId],[TemplateThemeId],[TemplateThemeItemId],[TranscriptionId],[CreatedDate],[CreatedByUserId],[TimeStamp])';
        SQL += 'VALUES(\'';
        SQL += vcc;
        SQL += '\', \'';
        SQL += studyId;
        SQL += '\', \'';
        SQL += idatha.templateThemeId;
        SQL += '\', \'';
        SQL += idatha.templateThemeItemId;
        SQL += '\', \'';
        SQL += obj.id;
        SQL += '\', GETUTCDATE(), \'';
        if (userId) {
            SQL += userId;
        }
        SQL += '\', GETUTCDATE()); ';
        SQL += '\n\n';
    }
    return SQL;
}
exports.saveStudyResultSummaryDetail = saveStudyResultSummaryDetail;
function processFinalResults(vcc, studyId, userId, idatha) {
    console.log(1183, idatha.results);
    var SQL = '', lenResults = idatha.results.length, lenWords, result, word, durationIn = 0, silenceIn = 0, durationOut = 0, silenceOut = 0, confidenceIn = 0, confidenceOut = 0, arrayConfidenceIn = [], arrayConfidenceOut = [], lenWordsIn = 0, lenWordsOut = 0, i, j;
    for (i = 0; i < lenResults; i++) {
        result = idatha.results[i];
        if (result && result.words && result.words.length > 0) {
            lenWords = result.words.length;
            for (j = 0; j < lenWords; j++) {
                word = result.words[j];
                if (word.speaker === 'in') {
                    durationIn += word.duration;
                    silenceIn += word.silence < 0 ? 0 : word.silence;
                    confidenceIn += word.confidence;
                }
                else {
                    durationOut += word.duration;
                    silenceOut += word.silence < 0 ? 0 : word.silence;
                    confidenceOut += word.confidence;
                }
            }
            lenWordsIn = result.words.filter(function (x) {
                return x.speaker === 'in';
            }).length;
            lenWordsOut = result.words.filter(function (x) {
                return x.speaker === 'out';
            }).length;
            if (lenWordsIn > 0) {
                confidenceIn = (confidenceIn / lenWordsIn);
                arrayConfidenceIn.push(confidenceIn);
            }
            if (lenWordsOut > 0) {
                confidenceOut = (confidenceOut / lenWordsOut);
                arrayConfidenceOut.push(confidenceOut);
            }
            SQL += 'INSERT INTO [dbo].[StudyDetail]([VCC],[StudyId],[TemplateThemeId],[TemplateThemeItemId],[TranscriptionId],[Total],[Duration],[Silence],[Confidence],[CreatedDate],[CreatedByUserId],[TimeStamp])';
            SQL += 'VALUES(\'';
            SQL += vcc;
            SQL += '\', \'';
            SQL += studyId;
            SQL += '\', \'';
            SQL += idatha.templateThemeId;
            SQL += '\', \'';
            SQL += idatha.templateThemeItemId;
            SQL += '\', \'';
            SQL += result.id;
            SQL += '\', 1, ';
            SQL += (durationIn + durationOut);
            SQL += ', ';
            SQL += (silenceIn + silenceOut);
            SQL += ', ';
            SQL += ((confidenceIn + confidenceOut) / 2);
            SQL += ', GETUTCDATE(), \'';
            if (userId) {
                SQL += userId;
            }
            SQL += '\', GETUTCDATE()); ';
            SQL += '\n\n';
            durationIn = 0;
            silenceIn = 0;
            durationOut = 0;
            silenceOut = 0;
        }
    }
    return SQL;
}
exports.processFinalResults = processFinalResults;
function getUniqueFinalResults(data) {
    function findDuplicate(x) {
        return x.templateThemeId === obj.templateThemeId;
    }
    var result = [], len = data.length, obj, item, i;
    for (i = 0; i < len; i++) {
        obj = data[i];
        item = result.find(findDuplicate);
        if (item) {
            item.results = item.results.concat(obj.results);
            item.results = item.results.filter(function (value, index, self) {
                return self.map(function (e) { return e.id; }).indexOf(value.id) === index;
            });
        }
        else {
            result.push(obj);
        }
    }
    return result;
}
exports.getUniqueFinalResults = getUniqueFinalResults;
function getPercentage(items, currentItem) {
    var result = null, index = items.findIndex(function (x) {
        return x.id === currentItem;
    });
    index += 1;
    result = (index * 1) / items.length;
    return {
        index: index,
        percentage: result
    };
}
exports.getPercentage = getPercentage;
var nlu = (function (o) {
    o.existInTemplateThemeItems = function (templateThemeItems, nlu, intents) {
        function filterIntents(x) {
            return x.id === [nlu, intent.intent].join('|');
        }
        var i, len = intents.length, intent, result, validIntents = [];
        for (i = 0; i < len; i++) {
            intent = intents[i];
            result = templateThemeItems.filter(filterIntents);
            if (result && result.length > 0) {
                validIntents.push(intent);
            }
        }
        return validIntents;
    };
    o.buildPhrases = function (words) {
        var i, len = words.length, word, phrase = '', phrasesArray = [], previousContent = '';
        for (i = 0; i < len; i++) {
            word = words[i];
            if (previousContent.length > 0) {
                phrase += previousContent;
                phrase += ' ';
            }
            phrase += word.name;
            phrase += ' ';
            if (phrase.length <= 500) {
                previousContent = '';
            }
            else {
                phrase = phrase.replace(word.name, '');
                previousContent = word.name;
                phrasesArray.push({ phrase: phrase, length: phrase.length, lastWord: word.name });
                phrase = '';
            }
        }
        phrasesArray.push({ phrase: phrase, length: phrase.length, lastWord: word.name });
        return phrasesArray;
    };
    o.validate = function (data) {
        var string_500 = [], phrases = '', len = data.transcription.length, item, phrasesResult = '', total = 0;
        for (var i = 0; i < len; i++) {
            item = data.transcription[i];
            if (data.init === 'out') {
                phrases += item.out;
                phrases += ' ';
                phrases += item.in;
            }
            else {
                phrases += item.in;
                phrases += ' ';
                phrases += item.out;
            }
            total = phrasesResult.length + phrases.length;
            if (total > 500) {
                string_500.push({ content: '', length: 0 });
                phrases = '';
                phrasesResult = '';
            }
            else {
                phrasesResult += phrases;
                if (string_500.length === 0) {
                    string_500.push({ content: phrasesResult, length: phrasesResult.length });
                }
                else {
                    string_500[string_500.length - 1].content += phrases;
                    string_500[string_500.length - 1].length = string_500[string_500.length - 1].content.length;
                }
            }
            phrases = '';
        }
        return string_500;
    };
    o.finalData = [];
    o.getData = function (intents) {
        function findIntent(x) {
            return x.intent === intentItem.intent;
        }
        if (intents && intents.length) {
            intents = intents.filter(function (x) {
                return x.intent !== 'None';
            });
        }
        else {
            return o.finalData;
        }
        if (o.finalData.length === 0) {
            o.finalData = intents;
        }
        else {
            var i, len = o.finalData.length, intentItem, foundIntent;
            for (i = 0; i < len; i++) {
                intentItem = o.finalData[i];
                foundIntent = intents.find(findIntent);
                if (foundIntent) {
                    intentItem.score = foundIntent.score > intentItem.score ? foundIntent.score : intentItem.score;
                }
            }
        }
        return o.finalData;
    };
    o.threshold = 0.00000005;
    o.getDataByThresholdMax = function (intents) {
        var result = [];
        result = intents.filter(function (x) {
            return x.score > o.threshold;
        });
        return result;
    };
    o.flatteningData = function (data, templateThemeItems) {
        function findInteraction(x) {
            return x.id === interactionItem.id && x.section === interactionItem.section && x.part === interactionItem.part;
        }
        function filterIntents(x) {
            return x.nlu === phraseItem.nlu;
        }
        function findIndex(x) {
            return x.nlu === phraseItem.nlu;
        }
        function mapPhrasesMaxIntents(x) {
            o.finalData = [];
            return {
                nlu: x.nlu,
                intents: x.intents.map(function (y) {
                    return o.getData(y);
                })[0]
            };
        }
        function mapPhrasesThresholdMax(x) {
            return {
                nlu: x.nlu,
                intents: o.getDataByThresholdMax(x.intents)
            };
        }
        function mapPhrasesExistInTemplateThemeItems(x) {
            return {
                nlu: x.nlu,
                intents: o.existInTemplateThemeItems(templateThemeItems, x.nlu, x.intents)
            };
        }
        var interactions = [], i, j, leni = data.length, lenj, interaction = null, interactionItem, index = -1, phrases;
        for (i = 0; i < leni; i++) {
            interaction = data[i];
            interaction = [].concat.apply([], interaction);
            lenj = interaction.length;
            for (j = 0; j < lenj; j++) {
                interactionItem = interaction[j];
                index = interactions.findIndex(findInteraction);
                if (index === -1) {
                    interactions.push({
                        id: interactionItem.id,
                        section: interactionItem.section,
                        part: interactionItem.part
                    });
                }
            }
        }
        leni = interactions.length;
        interactionItem = null;
        phrases = [];
        index = -1;
        var phraseItem, nlus = [];
        for (i = 0; i < leni; i++) {
            interactionItem = interactions[i];
            data[i] = [].concat.apply([], data[i]);
            phrases = data[i];
            nlus = [];
            if (phrases && phrases.length > 0) {
                lenj = phrases.length;
                for (j = 0; j < lenj; j++) {
                    phraseItem = phrases[j];
                    var intents = phrases.filter(filterIntents);
                    index = -1;
                    index = nlus.findIndex(findIndex);
                    if (index === -1) {
                        nlus.push({
                            nlu: intents[0].nlu,
                            intents: intents.map(function (x) {
                                return x.intents;
                            })
                        });
                    }
                }
                interactionItem.phrases = nlus;
                interactionItem.phrases = interactionItem.phrases.map(mapPhrasesMaxIntents);
                interactionItem.phrases = interactionItem.phrases.map(mapPhrasesThresholdMax);
                interactionItem.phrases = interactionItem.phrases.map(mapPhrasesExistInTemplateThemeItems);
            }
        }
        console.log(JSON.stringify(interactions));
        return interactions;
    };
    o.setInput = function (vcc, studyId, userId, interactions, templateThemeItems) {
        function filterTemplateThemeItems(x) {
            return x.id === [nluItem.nlu, intentItem.intent].join('|');
        }
        function findIndex(x) {
            return x.id === [interaction.id, interaction.section, interaction.part].join('_') && x.templateThemeId === themeItem.templateThemeId && x.templateThemeItemId === themeItem.templateThemeItemId;
        }
        var SQLResult = '';
        if (interactions && interactions.length > 0 && templateThemeItems && templateThemeItems.length > 0) {
            var idatha = { results: [] }, i, j, k, l, leni = interactions.length, lenj, lenk, lenl, interaction, nluItem, intentItem, themeItems = [], themeItem, index = -1;
            for (i = 0; i < leni; i++) {
                interaction = interactions[i];
                if (interaction.phrases && interaction.phrases.length > 0) {
                    lenj = interaction.phrases.length;
                    for (j = 0; j < lenj; j++) {
                        nluItem = interaction.phrases[j];
                        if (nluItem.intents && nluItem.intents.length > 0) {
                            lenk = nluItem.intents.length;
                            for (k = 0; k < lenk; k++) {
                                intentItem = nluItem.intents[k];
                                themeItems = templateThemeItems.filter(filterTemplateThemeItems);
                                if (themeItems && themeItems.length > 0) {
                                    lenl = themeItems.length;
                                    for (l = 0; l < lenl; l++) {
                                        themeItem = themeItems[l];
                                        index = idatha.results.findIndex(findIndex);
                                        if (index === -1) {
                                            idatha.results.push({
                                                id: [interaction.id, interaction.section, interaction.part].join('_'),
                                                templateThemeId: themeItem.templateThemeId,
                                                templateThemeItemId: themeItem.id
                                            });
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            SQLResult = o.saveStudyResultSummaryDetail(vcc, studyId, userId, idatha);
            SQLResult += o.processFinalResults(vcc, studyId, userId, idatha);
        }
        else {
            SQLResult = 'NO_INTERACTIONS_NO_TEMPLATE_THEME_ITEMS';
        }
        return SQLResult;
    };
    o.saveStudyResultSummaryDetail = function (vcc, studyId, userId, idatha) {
        var len = idatha.results.length, obj, SQL = '', i;
        for (i = 0; i < len; i++) {
            obj = idatha.results[i];
            SQL += 'INSERT INTO [dbo].[StudyResultSummaryDetail]([VCC],[StudyId],[TemplateThemeId],[TemplateThemeItemId],[TranscriptionId],[CreatedDate],[CreatedByUserId],[TimeStamp])';
            SQL += 'VALUES(\'';
            SQL += vcc;
            SQL += '\', \'';
            SQL += studyId;
            SQL += '\', \'';
            SQL += obj.templateThemeId;
            SQL += '\', \'';
            SQL += obj.templateThemeItemId;
            SQL += '\', \'';
            SQL += obj.id;
            SQL += '\', GETUTCDATE(), \'';
            if (userId) {
                SQL += userId;
            }
            SQL += '\', GETUTCDATE()); ';
            SQL += '\n\n';
        }
        return SQL;
    };
    o.processFinalResults = function (vcc, studyId, userId, idatha) {
        var SQL = '', lenResults = idatha.results.length, result, durationIn = 0, silenceIn = 0, durationOut = 0, silenceOut = 0, confidenceIn = 0, confidenceOut = 0, i;
        for (i = 0; i < lenResults; i++) {
            result = idatha.results[i];
            SQL += 'INSERT INTO [dbo].[StudyDetail]([VCC],[StudyId],[TemplateThemeId],[TemplateThemeItemId],[TranscriptionId],[Total],[Duration],[Silence],[Confidence],[CreatedDate],[CreatedByUserId],[TimeStamp])';
            SQL += 'VALUES(\'';
            SQL += vcc;
            SQL += '\', \'';
            SQL += studyId;
            SQL += '\', \'';
            SQL += result.templateThemeId;
            SQL += '\', \'';
            SQL += result.templateThemeItemId;
            SQL += '\', \'';
            SQL += result.id;
            SQL += '\', 1, ';
            SQL += (durationIn + durationOut) || 0;
            SQL += ', ';
            SQL += (silenceIn + silenceOut) || 0;
            SQL += ', ';
            SQL += ((confidenceIn + confidenceOut) / 2) || 0;
            SQL += ', GETUTCDATE(), \'';
            if (userId) {
                SQL += userId;
            }
            SQL += '\', GETUTCDATE()); ';
            SQL += '\n\n';
        }
        return SQL;
    };
    return o;
}(nlu || {}));
