"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function GetCompareItemsFromObjectArray(oldArr, newArr, keyProperty) {
    if (!oldArr)
        oldArr = [];
    if (!newArr)
        newArr = [];
    var newItems = [];
    var oldItems = [];
    var removedItems = [];
    oldArr.map(function (oa) {
        if (!newArr.find(function (na) { return na[keyProperty] === oa[keyProperty]; }))
            removedItems.push(oa);
        else
            oldItems.push(oa);
    });
    newArr.map(function (na) {
        if (!oldArr.find(function (oa) { return oa[keyProperty] === na[keyProperty]; }))
            newItems.push(na);
    });
    return {
        new: newItems,
        old: oldItems,
        removed: removedItems
    };
}
exports.GetCompareItemsFromObjectArray = GetCompareItemsFromObjectArray;
function GetUniqueFromArray(arr) {
    var reducedArray = arr.reduce(function (unique, item) {
        return unique.includes(item) ? unique : unique.concat([item]);
    }, []);
    return reducedArray;
}
exports.GetUniqueFromArray = GetUniqueFromArray;
function GetUniqueFromObjectArray(arr, value) {
    var unique = arr
        .map(function (e) { return e[value]; })
        .map(function (e, i, final) { return final.indexOf(e) === i && i; })
        .filter(function (e) { return arr[e]; }).map(function (e) { return arr[e]; });
    return unique;
}
exports.GetUniqueFromObjectArray = GetUniqueFromObjectArray;
function SortObjectArrayByValue(arr, property, sortType) {
    var sortedObjectArray = [];
    switch (sortType) {
        case 'A':
            sortedObjectArray = arr.sort(function (a, b) { return (a[property] < b[property] ? -1 : 1); });
            break;
        case 'D':
            sortedObjectArray = arr.sort(function (a, b) { return (a[property] > b[property] ? -1 : 1); });
            break;
    }
    return sortedObjectArray;
}
exports.SortObjectArrayByValue = SortObjectArrayByValue;
function SortObjectArrayByShuffle(arr) {
    var _a;
    var currentIndex = arr.length, randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex--;
        _a = [
            arr[randomIndex], arr[currentIndex]
        ], arr[currentIndex] = _a[0], arr[randomIndex] = _a[1];
    }
    return arr;
}
exports.SortObjectArrayByShuffle = SortObjectArrayByShuffle;
